function register_bit_match_and_place(x, y, name, bit, n)
   local nl = match(n, "GNR=t(gnnr, r, nr) B=t(r, nr, gnr) C=d(nr, nr, pnnr) D=d(r, r, pnr) E=t(nab, abc, nr) F=t(ab, abc, r) G=t(nr, dbc, ndb) H=t(r, dbc, db) I=gnd(gnnr) J=gnd(gnr) K=vcc(pnnr) L=vcc(pnr) nab~*nab* ab~*_ab* ndb~*ndb* db~*_db*")
   if(nl) then
      move(nl, x, y, "C -5 5 enr, K -6 9, GNR -5 -5 egnnr, I -6 -9, D 5 5 wr, L 6 9, B 5 -5 wgnr, J 6 -9, H 12 2 nr, F 12 -2 sr, G -12 2 nndb, E -12 -2 snab")
      route(nl, x, y, "dbc -12 12 12 12, abc -12 -12 12 -12, nab -18 -1, db 18 1, nr -6 0 -7 0 -8 0, r 6 0 7 0 8 0")
   end
   return nl
end

function register_bit(x, y, name, bit)
   local n = nodes_rect(x-50, y+20, x+50, y-30)

   if(verb) then
      for k,v in pairs(n) do
	 local xx, yy = v:pos();
	 print(k, xx-x, yy-y, v)
      end
   end

   local keep_plus, keep_plus_dx, keep_minus, keep_minus_dx
   local kills = {}
   for k,node in pairs(n) do
      if(tostring(node) == "vcc") then
	 local xx, yy = node:pos();
	 local dx = xx-x
	 local dy = yy-y
	 if(dy > 0) then
	    if(dx < 0) then
	       if((not keep_minus) or (keep_minus_dx < dx)) then
		  if(keep_minus) then
		     kills[#kills+1] = keep_minus
		  end
		  keep_minus = k
		  keep_minus_dx = dx
	       else
		  kills[#kills+1] = k
	       end
	    else
	       if((not keep_plus) or (keep_plus_dx > dx)) then
		  if(keep_plus) then
		     kills[#kills+1] = keep_plus
		  end
		  keep_plus = k
		  keep_plus_dx = dx
	       else
		  kills[#kills+1] = k
	       end
	    end
	 else
	    kills[#kills+1] = k
	 end
      end
   end

   for i=1,#kills do
      n[kills[i]] = nil
   end

   return register_bit_match_and_place(x, y, name, bit, n)
end

function latch(n, x, y, c)
   local nl = match(n, "L=t(ro, ro, ri) IR=t(nr, ri, gnd1) GND1=gnd(gnd1) PR=d(vcc1, ro, ro) VCC1=vcc(vcc1) INR=t(ro, nr, gnd2) GND2=gnd(gnd2) PNR=d(vcc2, nr, nr) VCC2=vcc(vcc2)", c)
   move(nl, x, y, "L 4 14 wri, IR 16 6 wgnd1, GND1 17 2, PR 4 22 wro, VCC1 5 26, INR 8 14 egnd2, GND2 7 10, PNR 16 14 wnr, VCC2 17 18")
   route(nl, x, y, "ro 0 18, nr 12 10, ri 5 6")
   return nl
end

function latchi(n, x, y, c)
   local nl = match(n, "L=t(ro, ro, ri) IR=t(nr, ri, gnd1) GND1=gnd(gnd1) PR=d(vcc1, ro, ro) VCC1=vcc(vcc1) INR=t(ro, nr, gnd2) GND2=gnd(gnd2) PNR=d(vcc2, nr, nr) VCC2=vcc(vcc2)", c)
   move(nl, x, y, "L -4 14 eri, IR -16 6 egnd1, GND1 -17 2, PR -4 22 ero, VCC1 -5 26, INR -8 14 wgnd2, GND2 -7 10, PNR -16 14 enr, VCC2 -17 18")
   route(nl, x, y, "ro 0 18, nr -12 10, ri -5 6")
   return nl
end

function xor(n, x, y, c) -- (a, b) -> x
   local nl = match(n, "XA=t(y, xb, xf) XB=t(xb, b, xg) XC=t(xb, a, xh) XD=t(xd, a, xi) XE=d(xj, y, y) XF=d(xb, xb, xk) XG=t(y, b, xd) XH=gnd(xf) XI=gnd(xg) XJ=gnd(xh) XK=gnd(xi) XL=vcc(xj) XM=vcc(xk)", c)
   move(nl, x, y, "XF -10 -8 exb, XM -11 -4, XE 3 0 wy, XL 4 4, XB -10 -16 exg, XI -11 -20, XA 3 -8 wxf, XH 4 -12, XC -12 -26 exh, XJ -13 -30, XD -2 -26 wxi, XK -1 -30, XG -2 -16 wxd")
   route(nl, x, y, "y -1 -4, xb -13 -12, a -8 -33, b -6 -33")
   return nl
end
