megabus = {}

-- r16h = ssp h
-- r15h = usp

-- r1l  = ssp l

for y=0,17 do
   for x=0,15 do
      local nl = register_bit(553+69*x, 4106-27*y, string.format("r%dh", y), 31-x)
      if(x == 15) then
	 megabus[string.format("r%dh_abc", y)] = nl.abc
	 megabus[string.format("r%dh_dbc", y)] = nl.dbc
      end
   end
end

for x=0,15 do
   local nl = register_bit(553+69*x, 3305, "r18h", 31-x)
   if(x == 15) then
      megabus.r18h_abc = nl.abc
      megabus.r18h_dbc = nl.dbc
   end
end


for y=0,9 do
   for x=0,15 do
      local nl = register_bit(553+69*x, 2461-27*y, string.format("r%dl", y), 15-x)
      if(x == 15) then
	 megabus[string.format("r%dl_abc", y)] = nl.abc
	 megabus[string.format("r%dl_dbc", y)] = nl.dbc
      end
   end
end

for y=0,8 do
   for x=0,15 do
      local nl = register_bit(553+69*x, 1940-27*y, string.format("r%dd", y), 15-x)
      if(x == 15) then
	 megabus[string.format("r%dd_abc", y)] = nl.abc
	 megabus[string.format("r%dd_dbc", y)] = nl.dbc
      end
   end
end


for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-40, 3643, xx+36, 3471)
   local nl = match(n, [[
U3=t(n9, n1, n16)
U4=t(n17, n3, n10)
U6=d(n9, n9, n19)
U7=d(n20, n10, n10)
U8=t(n1, n6, nr)
U9=t(n2, n6, ro)
U10=t(ri, n7, n9)
U11=t(n10, n8, ri)
U12=t(ri, n11, n12)
U16=gnd(n16)
U17=gnd(n17)
U19=vcc(n19)
U20=vcc(n20)

N0=t(n15, n18, n35)
N1=t(n18, n15, n36)
N2=t(n4, n5, n30)
N3=t(n31, n4, n5)
N6=t(n12, n27, n34)
N7=t(n22, n24, n37)
N8=t(n23, n12, n38)
N9=t(n39, n12, n24)
N12=d(n12, n12, n42)
N13=d(n15, n15, n43)
N14=d(n18, n18, n44)
N15=d(n24, n24, n45)
N16=t(n1, n14, n18)
N17=t(n1, n26, n24)
N18=t(n2, n26, n12)
N19=t(n2, n14, n15)
N20=t(n18, n13, n3)
N21=t(n24, n25, n3)
N22=t(n12, n25, n0)
N23=t(n15, n13, n0)
N25=t(n15, n21, n22)
N26=t(n18, n21, n23)
N27=t(n24, n24, n27)
N28=t(n27, n28, n29)
N29=gnd(n30)
N30=gnd(n31)
N33=gnd(n34)
N34=gnd(n35)
N35=gnd(n36)
N36=gnd(n37)
N37=gnd(n38)
N38=gnd(n39)
N42=vcc(n43)
N43=vcc(n44)
N44=vcc(n45)
]])

   local ln = latch(n, xx-3, 3596, { ro = nl.ro })
   local ln2 = latchi(n, xx+9, 3499, { ro = nl.n24 })

   move(nl, xx, 3600, [[
U8 -12 29 nn1,
U9 12 29 nro,
U10 -2 -2 sn9,
U6 -12 -15 en9,
U3 -14 -23 wn16,
U19 -13 -11,
U16 -13 -27,
U11 6 -2 sri,
U7 -4 -15 en10,
U4 -6 -23 wn17,
U20 -5 -11,
U17 -5 -27,
U12 6 -28 sri,
N26 -7 -64 en23,
N25 7 -64 wn22,
N8 -7 -72 en38,
N7 7 -72 wn37,
N37 -8 -76,
N36 8 -76,
N21 -12 -107 nn3,
N17 -12 -111 sn1,
N22 12 -107 nn12,
N18 12 -111 sn12,
N28 10 -121 nn27,
]])
   route(nl, xx, 3600, [[
ro 4 28,
nr 9 26 -8 26,
n0 18 -108,
n1 -18 28 -18 -110,
n3 -16 -20 -16 -28 -16 -30 -10 -30,
n9 -8 -1,
n8 6 -8,
n10 10 -15,
n12 22 -27 22 -68 -3 -68 -3 -110,
n21 0 -64 0 -60 2 -60 4 -60,
n24 2 -72 6 -108 6 -91 9 -91,
n27 4 -122
]])

   if(x ~= 0) then
      nl.n21:route(xx-4, 3540, xx-2, 3540)
   end

   local nlaob = register_bit_match_and_place(xx, 3554, "pch", 15-x, n)
   if(x == 15) then
      megabus.aobh_r = nl.n6
      megabus.aobh_d_w = nl.n8
      megabus.aobh_a_w = nl.n7
      megabus.aobh_auh_w = nl.n11
      megabus.pch_abc = nlaob.abc
      megabus.pch_dbc = nlaob.dbc
      megabus.pch_auh_w = nl.n21
      megabus.auh_d_w = nl.n25
      megabus.auh_a_w = nl.n26
      megabus.auh_aluh_w = nl.n28
   end

   if(x == 0 or x >= 8) then
      local nld = match(n, "XN0=t(xn0, ri, xn13) XN5=t(xn18, nr, xn0) XN13=gnd(xn13) XN18=vcc(xn18)", ln)
      move(nld, xx, 3600, "XN0 -13 6 exn13, XN13 -14 2, XN5 -13 14 exn0, XN18 -14 18")
      local k1 = {}
      for k,v in pairs(nl) do
	 k1[v] = l
      end
      for k,v in pairs(nld) do
	 if(k1[v]) then
	    print(k, k1[v])
	 end
      end
      if(x0 ~= 0) then
	 route(nld, xx, 3600, "xn0 -20 10 -20 550, nr -8 14")
      end
   end
end

local xi = {}
for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-40, 3470, xx+32, 3325)
   local nl = xor(n, xx+7, 3420)
   nl.y:route(xx+14, 3416)

   local nl2 = xor(n, xx, 3380, { y = nl.a })
   local nl3 = match(n, "A=t(n1, n2, a) B=t(n3, n4, a) n1~*nabh*", {a=nl2.a})
   move(nl3, xx, 3420, "A -12 -76 sn1, B 0 -76 sa")
   route(nl2, xx, 3420, "b -16 -73 -16 -56 -16 -61 -16 -66 -6 -61 -6 -66 -11 -73")
   route(nl3, xx, 3420, "n1 -18 -75, n4 0 -82, n3 4 -84")
   if(x == 15) then
      megabus.aluh_ab_in = nl3.n2
      megabus.aluh_cst_in = nl3.n4
      megabus.aluh_cst_val = nl3.n3
   end
   if(x ~= 0) then
      local nl4 = match(n, "A=t(c, e, f) C=t(c, a, h) D=t(b, d, c) E=gnd(f) G=vcc(h)", {e=nl2.xb})
      move(nl4, xx, 3420, "C -26 -51 ec, G -27 -47, A -26 -59 ef, E -27 -63, D -25 -32 nc")
      route(nl4, xx, 3420, "c -29 -40 -29 -55, a -22 -86, d -10 -28 -10 -35 -1 -35, e -13 -59")
      if((x % 4) == 3) then
	 local nl5 = match(n, "A=t(a, b, c) B=vcc(a)", {b=nl4.a, c=nl4.b})
	 move(nl5, xx, 3420, "A -26 -40 ec, B -27 -36")
	 route(nl5, xx, 3420, "c -20 -44 -20 -33")
      end
      if(x >= 4) then
	 local nl6 = match(n, "A=d(v, a, a) B=t(a, b, g) V=vcc(v) G=gnd(g)", {b=nl4.d})
	 move(nl6, xx, 3420, "A -29 -10 ea, B -29 -18 eg, V -30 -6, G -30 -22")
	 xi[string.format("x%d", x)] = nl6.a
      end
      if((x % 4) == 0) then
	 local nl7 = match(n, "A=d(v, a, a) B=t(a, b, g) C=t(c, a, g2) V=vcc(v) G=gnd(g) G2=gnd(g2)", {b=nl4.c})
	 move(nl7, xx, 3420, "A -33 -25 ea, B -33 -33 eg, V -34 -21, G -34 -37, C -40 -33 eg2, G2 -41 -37")
	 route(nl7, xx, 3420, "a -36 -29, c -44 -29 -44 -33")
      end
   end
end

local n = nodes_rect(755, 3475, 1630, 3430)
local nl = match(n, [[
N0=t(n0, x5, n9)
N1=t(n0, x8, n10)
N2=t(n0, x9, n11)
N3=t(n0, x10, n12)
N4=t(n0, x11, n13)
N5=t(n0, x12, n14)
N6=t(n0, x13, n15)
N7=t(n0, x14, n16)
N8=t(n0, x15, n17)
N9=t(n0, n3, n18)
N10=t(n0, x4, n19)
N11=t(n0, x6, n20)
N12=t(n0, x7, n21)
N13=t(n22, x8, n1)
N14=t(n23, x9, n1)
N15=t(n24, x10, n1)
N16=t(n25, x11, n1)
N17=t(n26, x12, n1)
N18=t(n27, x13, n1)
N19=t(n28, x14, n1)
N20=t(n29, x15, n1)
N21=t(n1, n3, n30)
N22=t(n31, n0, n2)
N23=t(n2, n6, n32)
N24=t(n33, n1, n4)
N25=t(n4, n7, n34)
N26=t(n5, x12, n35)
N27=t(n5, x13, n36)
N28=t(n5, x14, n37)
N29=t(n5, x15, n38)
N30=t(n5, n3, n39)
N31=t(n6, x5, n40)
N32=t(n41, x4, n6)
N33=t(n42, x6, n6)
N34=t(n43, x7, n6)
N35=t(n44, n4, n6)
N36=t(n45, x8, n7)
N37=t(n7, x9, n46)
N38=t(n7, x10, n47)
N39=t(n7, x11, n48)
N40=t(n49, n8, n7)
N41=t(n50, n5, n8)
N42=d(n0, n0, n51)
N43=d(n52, n1, n1)
N44=d(n53, n5, n5)
N45=d(n6, n6, n54)
N46=d(n7, n7, n55)
N47=gnd(n9)
N48=gnd(n10)
N49=gnd(n11)
N50=gnd(n12)
N51=gnd(n13)
N52=gnd(n14)
N53=gnd(n15)
N54=gnd(n16)
N55=gnd(n17)
N56=gnd(n18)
N57=gnd(n19)
N58=gnd(n20)
N59=gnd(n21)
N60=gnd(n22)
N61=gnd(n23)
N62=gnd(n24)
N63=gnd(n25)
N64=gnd(n26)
N65=gnd(n27)
N66=gnd(n28)
N67=gnd(n29)
N68=gnd(n30)
N69=gnd(n31)
N70=gnd(n32)
N71=gnd(n33)
N72=gnd(n34)
N73=gnd(n35)
N74=gnd(n36)
N75=gnd(n37)
N76=gnd(n38)
N77=gnd(n39)
N78=gnd(n40)
N79=gnd(n41)
N80=gnd(n42)
N81=gnd(n43)
N82=gnd(n44)
N83=gnd(n45)
N84=gnd(n46)
N85=gnd(n47)
N86=gnd(n48)
N87=gnd(n49)
N88=gnd(n50)
N89=vcc(n51)
N90=vcc(n52)
N91=vcc(n53)
N92=vcc(n54)
N93=vcc(n55)
]], xi)

move(nl, 0, 0, [[
N22 788 3474 en31,
N69 787 3470,
N23 788 3459 en32,
N70 787 3455,

N10 793 3470 en19,
N57 792 3466,
N32 793 3455 en41,
N79 792 3451,

N0 862 3470 en9,
N47 861 3466,
N31 862 3455 en40,
N78 861 3451,

N11 931 3470 en20,
N58 930 3466,
N33 931 3455 en42,
N80 930 3451,

N12 1000 3470 en21,
N59 999 3466,
N34 1000 3455 en43,
N81 999 3451,

N45 1034 3463 en6,
N92 1033 3467,
N35 1034 3455 en44,
N82 1033 3451,

N25 1064 3459 en34,
N72 1063 3455,
N24 1064 3444 en33,
N71 1063 3440,

N1 1069 3470 en10,
N48 1068 3466,
N36 1069 3455 en45,
N83 1068 3451,
N13 1069 3440 en22,
N60 1068 3436,

N2 1138 3470 en11,
N49 1137 3466,
N37 1138 3455 en46,
N84 1137 3451,
N14 1138 3440 en23,
N61 1137 3436,

N3 1207 3470 en12,
N50 1206 3466,
N38 1207 3455 en47,
N85 1206 3451,
N15 1207 3440 en24,
N62 1206 3436,

N4 1276 3470 en13,
N51 1275 3466,
N39 1276 3455 en48,
N86 1275 3451,
N16 1276 3440 en25,
N63 1275 3436,

N46 1310 3463 en7,
N93 1309 3467,
N40 1310 3455 en49,
N87 1309 3451,

N41 1340 3459 en50,
N88 1339 3454,

N5 1345 3470 en14,
N52 1344 3466,
N26 1345 3455 en35,
N73 1344 3451,
N17 1345 3440 en26,
N64 1344 3436,

N6 1414 3470 en15,
N53 1413 3466,
N27 1414 3455 en36,
N74 1413 3451,
N18 1414 3440 en27,
N65 1413 3436,

N7 1483 3470 en16,
N54 1482 3466,
N28 1483 3455 en37,
N75 1482 3451,
N19 1483 3440 en28,
N66 1482 3436,

N8 1552 3470 en17,
N55 1551 3466,
N29 1552 3455 en38,
N76 1551 3451,
N20 1552 3440 en29,
N67 1551 3436,

N9 1564 3470 en18,
N56 1563 3466,
N30 1564 3455 en39,
N77 1563 3451,
N21 1564 3440 en30,
N68 1563 3436,

N42 1585 3474 wn0,
N89 1586 3478,
N44 1585 3459 wn5,
N91 1586 3463,
N43 1585 3444 wn1,
N90 1586 3448,

]])

route(nl, 0, 0, [[
n2 785 3478 785 3463,
x4 797 3406,
x5 866 3406,
x6 935 3406,
x7 1004 3406,
n4 1061 3463 1061 3455 1061 3448 1061 3430,
x8 1073 3406,
x9 1142 3406,
x10 1211 3406,
x11 1280 3406,
n8 1337 3463 1337 3455 1337 3430,
x12 1349 3406,
x13 1418 3406,
x14 1487 3406,
x15 1556 3406,
]])


for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-34, 2207, xx+34, 1956)
   local nl = match(n, [[
n2~*_ab*
n3~*_nab*
n4~*_db*
n5~*_ndb*
N29=t(n5, n4, n6)
N27=t(n4, n5, n6)
N0=t(n16, n1, n6)
N31=gnd(n16)
N1=t(n17, n1, n7)
N32=gnd(n17)
N24=t(n3, n2, n7)
N22=t(n2, n3, n7)
N10=t(n3, n0, n21)
N36=vcc(n21)
N9=t(n2, n0, n20)
N35=vcc(n20)
N21=t(n3, n0, n2)
N12=t(n23, n0, n5)
N38=vcc(n23)
N11=t(n4, n0, n22)
N37=vcc(n22)
N26=t(n5, n0, n4)
N30=t(n5, n8, n9)
N28=t(n4, n8, n10)
N25=t(n3, n11, n12)
N23=t(n2, n11, n13)
N17=t(n12, n28, n28)
N43=vcc(n28)
N19=t(n13, n30, n30)
N45=vcc(n30)
N13=t(n24, n24, n9)
N39=vcc(n24)
N15=t(n26, n26, n10)
N41=vcc(n26)
N99=t(n9, n0, n10)
N14=t(n9, n0, n25)
N40=vcc(n25)
N16=t(n10, n0, n27)
N42=vcc(n27)
N18=t(n29, n0, n12)
N44=vcc(n29)
N20=t(n13, n0, n31)
N46=vcc(n31)
N6=t(n12, n0, n13)
N7=t(n12, n13, n14)
N8=t(n13, n12, n14)
N3=t(n19, n1, n15)
N34=gnd(n19)
N4=t(n9, n10, n15)
N5=t(n10, n9, n15)
]])
   local nl1 = match(n, "N2=t(n18, n1, n14) N33=gnd(n18)", nl)

   move(nl, xx, 2207, [[
N29 -12 -9 sn5,
N27 12 -7 nn6,
N0 4 -20 sn6,
N31 8 -19,
N1 -4 -28 nn17,
N32 -8 -29,
N24 -12 -39 sn3,
N22 12 -37 nn7,
N10 -12 -60 sn3,
N36 -8 -59,
N9 12 -60 sn20,
N35 8 -59,
N21 0 -56 sn3,
N12 -12 -72 nn5,
N38 -8 -73,
N11 12 -72 nn22,
N37 8 -73,
N26 0 -76 nn5,
N30 -15 -90 en9,
N28 19 -90 en10,
N25 -19 -100 wn12,
N23 15 -100 wn13,
N17 -22 -120 nn28,
N43 -22 -116,
N19 12 -120 nn30,
N45 12 -116,
N13 -12 -120 nn9,
N39 -12 -116,
N15 22 -120 nn10,
N41 22 -116,
N99 0 -136 sn9,
N14 -12 -140 sn9,
N40 -8 -139,
N16 12 -140 sn27,
N42 8 -139,
N18 -12 -152 nn12,
N44 -8 -153,
N20 12 -152 nn31,
N46 8 -153,
N6 0 -156 nn12,
N3 -4 -198 nn19,
N34 -8 -199,
N4 -12 -209 sn9,
N5 12 -207 nn15,
]])
   route(nl, xx, 2207, [[
n5 -16 -3 -16 -77,
n4 18 -13 18 -8 18 -77 18 -73,
n6 0 -8,
n3 -18 -33 -18 -38 -18 -55 -18 -59,
n2 16 -43 16 -55 16 -59,
n7 0 -38,
n0 0 -66 12 -66 -12 -66 -20 -66 0 -146 12 -146 -12 -146 -20 -146,
n8 23 -86 -11 -86,
n11 30 -104 11 -104 -23 -104,
n12 -18 -153 -18 -157 -18 -178 -18 -173,
n10 18 -135 18 -139 18 -208 18 -213,
n13 16 -157 16 -183,
n9 -16 -135 -16 -203,
n15 0 -208
]])

   if(x ~= 0) then
      nl.n8:route(xx-30, 2121)
   end

   if(x == 15) then
      megabus.ld_sense_amp_keep = nl.n1
      megabus.ld_d_connect = nl.n8
      megabus.ld_a_connect = nl.n11
   end
   if(nl1) then
      move(nl1, xx, 2207, "N2 4 -190 sn14, N33 8 -189")
      move(nl, xx, 2207, "N7 -12 -179 sn12, N8 12 -177 nn14")
      route(nl, xx, 2207, "n14 0 -178")
   else
      nl1 = match(n, "N2=t(n33, n32, n14) N33=t(n12, n18, n34) N47=t(n13, n18, n35) N48=gnd(n33) N49=vcc(n34) N50=vcc(n35)", nl)

      move(nl1, xx, 2207, [[
N2 4 -235 sn14,
N48 8 -234,
N33 -12 -250 nn12,
N49 -8 -251,
N47 12 -250 nn35,
N50 8 -251
]])
      move(nl, xx, 2207, "N7 -12 -224 sn12, N8 12 -222 nn14")
      route(nl, xx, 2207, "n12 -18 -218 -18 -223 -18 -251, n13 16 -228, n14 0 -223")
      if(x == 7) then
	 megabus.d_sense_amp_keep_8_15 = nl1.n32
	 megabus.d_clear_8_15 = nl1.n18
      end
   end
end

for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-34, 3294, xx+34, 3115)
   local nl = match(n, [[
N0=t(n18, n11, n3)
N1=t(n4, n12, n19)
N2=t(n16, n14, n1)
N3=t(n2, n9, n17)
N4=t(n20, n7, n5)
N5=t(n21, n6, n8)
N6=t(n22, n22, n1)
N7=t(n1, n0, n23)
N8=t(n24, n24, n2)
N9=t(n2, n0, n25)
N10=t(n3, n26, n26)
N11=t(n3, n0, n27)
N12=t(n4, n28, n28)
N13=t(n4, n0, n29)
N14=t(n1, n0, n2)
N15=t(n1, n2, n8)
N16=t(n1, n10, n15)
N17=t(n2, n1, n8)
N18=t(n2, n10, n13)
N19=t(n3, n4, n5)
N20=t(n4, n3, n5)
N35=t(n3, n30, n32)
N36=t(n4, n30, n31)
N37=t(n3, n0, n4)
N21=gnd(n16)
N22=gnd(n17)
N23=gnd(n18)
N24=gnd(n19)
N25=gnd(n20)
N26=gnd(n21)
N27=vcc(n22)
N28=vcc(n23)
N29=vcc(n24)
N30=vcc(n25)
N31=vcc(n26)
N32=vcc(n27)
N33=vcc(n28)
N34=vcc(n29)
n1~*_nab*
n2~*_ab*
n3~*_ndb*
n4~*_db*
]])

   move(nl, xx, 3294, [[
N19 -12 -9 sn3,
N20 12 -7 nn5,
N4 4 -20 sn5,
N25 8 -19,
N5 -4 -40 nn21,
N26 -8 -41,
N15 -12 -51 sn1,
N17 12 -49 nn8,

N14 0 -66 sn1,
N7 -12 -70 sn1,
N28 -8 -69,
N9 12 -70 sn25,
N30 8 -69,
N11 -12 -82 nn3,
N32 -8 -83,
N13 12 -82 nn29,
N34 8 -83,
N37 0 -86 nn3,

N6 -22 -100 nn22,
N27 -22 -96,
N10 -12 -100 nn3,
N31 -12 -96,
N8 12 -100 nn24,
N29 12 -96,
N12 22 -100 nn4,
N33 22 -96,

N2 -22 -110 sn16,
N21 -26 -109,
N0 -12 -110 sn3,
N23 -8 -109,
N3 12 -110 sn17,
N22 8 -109,
N1 22 -110 sn4,
N24 26 -109,

N16 -19 -140 wn15,
N18 15 -140 wn13,
N35 -15 -150 en32,
N36 19 -150 en31,

]])

   route(nl, xx, 3294, [[
n5 0 -8,
n8 0 -50,
n0 -12 -76 0 -76 12 -76 20 -76,
n3 -16 -3 -16 -83 -16 -87,
n4 18 -8 18 -13 18 -83 18 -87,
n1 -18 -45 -18 -50 -18 -65 -18 -69,
n2 16 -55 3 -55 11 -55 10 -65 16 -65 16 -69,
n10 -23 -136 11 -136 23 -136,
n30 -11 -154 23 -154,
n14 -22 -120,
n11 -12 -116,
n12 22 -118,
]])

   if(x == 15) then
      megabus.hd_sense_amp_keep = nl.n7
      megabus.ha_sense_amp_keep = nl.n6
      megabus.hl_a_connect = nl.n10
      megabus.hl_d_connect = nl.n30
   end      
end

for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-34, 743, xx+34, 679)
   local l = latch(n, xx, 700)
   local nl = match(n, "A=t(d, ri, a) B=t(e, nr, a) C=t(b, c, ri) D=gnd(d) E=vcc(e)", l)
   move(nl, xx, 700, "B 25 10 wa, E 26 14, A 25 2 wd, D 26 -2, C -2 28 eri")
   route(nl, xx, 700, "a 31 6, ri -3 6 12 -1 21 -1, c 2 32")
   nl.a:route(xx+31, 610-2*x, 1710, 610-2*x)
   if(x == 15) then
      megabus.ir_irc_w = nl.c
   end

   n = nodes_rect(xx-34, 777, xx+34, 743)
   l = latchi(n, xx+30, 735)
   nl = match(n, "A=t(d, nr, a) B=t(e, ro, a) C=t(b, c, ri) D=gnd(d) E=vcc(e)", l)
   move(nl, xx+30, 743, "B -25 10 ea, E -26 14, A -25 2 ed, D -26 -2, C 2 20 wri")
   route(nl, xx+30, 743, "a -33 6, ri 3 2, c -2 24, ro -21 13 -15 13 -7 13")
   nl.b:route(xx-22, 770+2*(15-x), xx+33, 770+2*(15-x))
   if(x <= 4) then
      nl.a:route(xx-3, 772+2*(15-x), 1635, 772+2*(15-x))
   end
   if(x == 0) then
      nl.a:route(1648, 802, 1648, 792, 1860, 792, 1860, 1280, 1980, 1280, 1980, 1840, 2180, 1840, 2180, 2327)
   end
   if(x == 1) then
      nl.a:route(1646, 800, 1646, 790, 1862, 790, 1862, 1278, 1982, 1278, 1982, 1838, 2186, 1838)
   end
   if(x == 2) then
      nl.a:route(1644, 798, 1644, 788, 1864, 788, 1864, 1276, 1984, 1276, 1984, 1836, 2184, 1836, 2184, 2267)
   end
   if(x == 3) then
      nl.a:route(1642, 796, 1642, 786, 1866, 786, 1866, 1274, 1986, 1274, 1986, 1834, 2182, 1834, 2182, 2297)
   end
   if(x == 4) then
      nl.a:route(1640, 794, 1640, 784, 1868, 784, 1868, 1272, 1988, 1272, 1988, 1383, 3028, 1383, 3028, 1278)
   end
   if(x == 15) then
      megabus.irc_edb_w = nl.c
   end

   n = nodes_rect(xx-34, 850, xx+34, 798)
   l = latch(n, xx-4, 820)
   nl = match(n, "A=t(c, nr, f) B=t(a, d, ri) C=t(ri, e, b) D=t(c, ro, g) E=gnd(f) F=vcc(g) a~*abd* b~*dbd*")
   move(nl, xx, 820, [[
D -4 30 sg,
F -8 31,
A 8 30 sc,
E 12 31,
B 12 -5 sri,
C 22 -5 sb,
]])
   route(nl, xx, 820, "c 2 31 2 60, b 18 50, a 16 50, ri 26 -2 8 -2, d 12 -11")
   
  
   if(x == 15) then
      megabus.dbd_to_alu_w = nl.e
      megabus.abd_to_alu_w = nl.d
      megabus.dbd_to_alu_w:route(1662, 811, 1662, 831)
      megabus.abd_to_alu_w:route(1662, 809, 1662, 804)
   end
end




local n = nodes_rect(530, 900, 1220, 854)
local nl = match(n, [[
N0=t(n10, n8, n29)
N1=t(n11, n20, n30)
N2=t(n20, n8, n31)
N3=t(n32, n20, n21)
N4=t(n24, n23, n33)
N5=t(n25, n8, n34)
N6=t(n35, n22, n27)
N7=t(n36, n23, n28)
N8=t(n12, n28, n0)
N9=t(n13, n28, n1)
N10=t(n14, n28, n2)
N11=t(n15, n28, n3)
N12=t(n16, n28, n4)
N13=t(n17, n28, n5)
N14=t(n18, n28, n6)
N49=t(n19, n28, n7)
N15=t(n7, n27, n9)
N16=t(n10, n20, n37)
N17=t(n11, n21, n38)
N18=t(n39, n25, n20)
N19=d(n21, n21, n40)
N20=d(n24, n24, n41)
N21=d(n42, n25, n25)
N22=d(n43, n27, n27)
N23=t(n44, n24, n28)
N24=t(n9, n22, n26)
N25=t(n11, n23, n12)
N26=t(n11, n23, n13)
N27=t(n11, n23, n14)
N28=t(n11, n23, n15)
N29=t(n11, n23, n16)
N30=t(n11, n23, n17)
N31=t(n11, n23, n18)
N32=t(n11, n23, n19)
N33=gnd(n29)
N34=gnd(n30)
N35=gnd(n31)
N36=gnd(n32)
N37=gnd(n33)
N38=gnd(n34)
N39=gnd(n35)
N40=gnd(n36)
N41=vcc(n37)
N42=vcc(n38)
N43=vcc(n39)
N44=vcc(n40)
N45=vcc(n41)
N46=vcc(n42)
N47=vcc(n43)
N48=vcc(n44)
n0~mbus_abd.15
n1~mbus_abd.14
n2~mbus_abd.13
n3~mbus_abd.12
n4~mbus_abd.11
n5~mbus_abd.10
n6~mbus_abd.9
n7~mbus_abd.8
n8~mbus_abd.7
]])
move(nl, 0, 0, [[
N8 565 869 sn12,
N25 545 869 sn11,
N9 634 869 sn13,
N26 614 869 sn11,
N10 703 869 sn14,
N27 683 869 sn11,
N11 772 869 sn15,
N28 752 869 sn11,
N12 841 869 sn16,
N29 821 869 sn11,
N13 910 869 sn17,
N30 890 869 sn11,
N14 979 869 sn18,
N31 959 869 sn11,
N49 1048 869 sn19,
N32 1028 869 sn11,

N20 1020 889 wn24,
N45 1021 893,
N23 1012 889 en28,
N48 1011 893,
N4 1020 881 wn33,
N37 1021 877,
N7 1012 881 en36,
N40 1011 877,

N19 1075 889 wn21,
N44 1076 893,
N17 1067 889 en11,
N42 1066 893,
N3 1075 881 wn32,
N36 1076 877,
N1 1067 881 en30,
N34 1066 877,

N15 1080 871 nn7,
N24 1095 871 nn9,

N22 1086 889 en27,
N47 1085 893,
N6 1086 881 en35,
N39 1085 877,

N21 1145 889 wn25,
N46 1146 893,
N18 1137 889 en20,
N43 1136 893,
N5 1145 881 wn34,
N38 1146 877,
N2 1137 881 en31,
N35 1136 877,

N16 1155 889 wn10,
N41 1156 893,
N0 1155 881 wn29,
N33 1156 877,
]])

route(nl, 0, 0, [[
n11 541 872 550 872 610 872 619 872 679 872 688 872 748 872 757 872 817 872 826 872 886 872 895 872 955 872 964 872 1024 872 1064 872 1064 885,
n23 545 863 550 863 614 863 619 863 683 863 688 863 752 863 757 863 821 863 826 863 890 863 895 863 959 863 964 863 1016 863 1028 863 1620 863,
n28 1009 885 1009 865,
n8 1141 870,
n27 1080 885,
n20 1071 868 1134 868 1134 885 1134 898 1148 898 1148 889,
n26 1620 870,
n22 1095 881 1620 875,
n10 1620 885,
]])

megabus.y885 = nl.n10
megabus.y875 = nl.n22
megabus.y870 = nl.n26
megabus.y863 = nl.n23

megabus.y885:route(1662, 885, 1662, 877, 1675, 877)
megabus.y870:route(1697, 870, 1697, 864)
megabus.y863:route(1662, 863, 1662, 853)



for x=0,7 do
   local xx = 553+69*x
   local n = nodes_rect(xx-34, 1000, xx+34, 900)
   local nl = match(n, [[
A=t(m, k, t)
B=t(u, k, q)
C=t(s, f, b)
D=d(m, m, v)
E=t(w, m, q)
F=t(b, g, a)
G=t(d, e, b)
H=t(c, o, k)
I=t(q, l, c)
J=t(j, h, k)
K=t(k, i, n)
L=t(k, p, r)
M=gnd(s)
N=gnd(t)
O=gnd(u)
P=vcc(v)
Q=vcc(w)
]])

   move(nl, xx, 950, [[
L 4 -50 sr,
H 4 -43 sc,
I -14 -36 sq,
D 2 -22 wm,
P 3 -18,
A 2 -30 wt,
N 3 -34,
E -6 -22 ew,
Q -7 -18,
B -6 -30 eu,
O -7 -34,
K 10 -10 sk,
J 2 -3 sj,
F 12 4 sb,
C 4 11 ss,
M 0 12,
G 4 40 sd,
]])
   route(nl, xx, 950, [[
q -18 -26,
k -2 -37 6 -37 8 -37,
n 14 -56 2 -56,
c -10 -42,
r 0 -80,
d 0 43,
a 18 5,
]])

   if(x == 0) then
      nl.j:route(xx-2, 968, 1644, 968, 1644, 991)
      megabus.y968 = nl.j
	  

	  
   else
      nl.j:route(xx-53, 948)
   end
end

for x=8,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-34, 1000, xx+34, 900)
   local nl = match(n, [[
A=t(s, m, p)
B=t(e, j, b)
C=t(c, k, m)
D=t(m, r, d)
E=d(p, p, t)
F=t(a, i, e)
G=t(g, h, e)
H=t(f, q, m)
I=t(p, n, f)
J=t(m, l, o)
K=gnd(s)
L=vcc(t)
d~*abd*
b~*dbd*
]])

   move(nl, xx, 950, [[
D 12 -50 sm,
H 4, -43 sf,
I -6 -36 sf,
A 4 -30 es,
K 3 -34,
E 2 -22 wp,
L 3 -18,
J 4 -10 so,
C 4 -3 sc,
B 12 4 se,
F 4 11 sa,
G 4 40 sg,
]])
   route(nl, xx, 950, [[
b 18 5,
f -10 -42,
o -12 -9 -12 -56 2 -56,
a -2 12,
g 0 43 20 43,
]])



   if(x == 8) then
      nl.c:route(xx-14, 948)
      megabus.y993 = nl.g
      megabus.y986 = nl.h
      megabus.y957 = nl.i
      megabus.y950 = nl.j
      megabus.y943 = nl.k
      megabus.y936 = nl.l
      megabus.y910 = nl.n
      megabus.y903 = nl.q
      megabus.y896 = nl.r
      megabus.y993:route(1660, 993, 1660, 1017)
      megabus.y986:route(1662, 986, 1662, 1006)
      megabus.y957:route(1646, 957, 1646, 971)
      megabus.y950:route(1662, 950, 1662, 954)
      megabus.y936:route(1697, 936, 1697, 932)
      megabus.y910:route(1662, 910, 1662, 922)
      megabus.y903:route(1697, 903, 1697, 911)
      megabus.y896:route(1662, 896, 1662, 900)
	  

	  
   else
      nl.c:route(xx-53, 948)
   end

   if(x == 8 or x == 11 or x == 12 or x == 15) then
      nl.a:route(xx-2, 962)
      nl.a:route(xx-2, 964)
      if(x ~= 8) then
	 nl.a:route(xx-20, 964)
      end
   else
      nl.a:route(xx-2, 962)
      nl.a:route(xx-2, 966)
      if(x == 10 or x == 14) then
	 nl.a:route(xx-20, 966)
      end
   end
end




local map = {}

for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-34, 3120, xx+34, 2975)
   local nl = xor(n, xx, 3060)
   local nl2 = xor(n, xx+7, 3121, {a = nl.y})
   local nl3 = match(n, [[
N0=t(n8, xb, n7)
N5=t(n13, n0, b_2)
N6=t(n1, n5, a)
N7=t(a, n6, n3)
N8=t(b_2, y, n7)
N9=gnd(n8)
N14=vcc(n13)
]], { a=nl.a, y=nl.y, xb = nl.xb, b_2 = nl2.b })
   move(nl3, xx, 3100, [[
N7 -22 -82 sa,
N6 -4 -80 sa,
N5 -10 -20 eb_2,
N14 -11 -16,
N8 -10 -28 en7,
N0 -10 -36 en8,
N9 -11 -40,
]])
   route(nl, xx, 3100, [[
b -16 -56 -16 -66 -16 -75 -6 -66 -6 -75,
]])
   route(nl2, xx, 3100, [[
y 6 13 13 17 13 13 13 9,
]])
   route(nl3, xx, 3100, [[
a -26 -79 -8 -79,
y -1 -28,
b_2 1 -24,
n0 -6 -13 20 -13,
n7 -13 -32 -13 -24,
]])


   if(x < 14) then
      nl3.n1:route(xx, 3023)
   end
   if(x == 13) then
      nl3.n1:route(1450, 3012, 1620, 3012)
      megabus.alul_bit_2p = nl3.n1
   end
   if(x == 14) then
      nl3.n1:route(1519, 3010, 1620, 3010)
      megabus.alul_bit_1 = nl3.n1
   end
   if(x == 15) then
      nl3.n1:route(1588, 3008, 1620, 3008)
      megabus.alul_bit_0 = nl3.n1
      megabus.alul_cst_in = nl3.n5
      megabus.alul_ab_in = nl3.n6
      megabus.alul_add1 = nl3.b_2
   end
   if(x < 12) then
      local nl4 = mmatch(n, "N1=t(n2, y, n12) N11=d(n2, n2, n18) N17=vcc(n18) N12=gnd(n12)", nl, nl2, nl3)
      move(nl4, xx, 3060, "N11 7 -22 wn2, N17 8 -18, N1 7 -30 wn12, N12 8 -34")
      route(nl4, xx, 3060, "y 1 -12 1 -30, n2 10 -26 10 -50")
      map[string.format("x%d", 15-x)] = nl4.n2
   end
   if(x == 0 or x == 4 or x == 8 or x == 12) then
      local nl5 = mmatch(n, "N2=t(n4, n9, n16) N3=t(n9, n7, n17) N15=t(n22, n0, n7) N16=d(n9, n9, n23) N18=gnd(n16) N19=gnd(n17) N23=vcc(n22) N24=vcc(n23)", nl, nl2, nl3)
      move(nl5, xx, 3060, "N15 -24 20 en7, N23 -25 24, N16 -31 16 en9, N24 -32 20, N3 -31 8 en17, N19 -32 4, N2 -36 12 en16, N18 -37 8")
      route(nl5, xx, 3060, "n0 -20 27, n7 -25 8 -19 16, n4 -41 16")
      map[string.format("y%d", x)] = nl5.n4
   end
   if(x >= 12) then
      local nl4 = match(n, [[
N1=t(n26, n26, n2)
N2=t(n27, n27, n3)
N3=t(n28, n28, n4)
N4=t(n29, n29, n5)
N32=vcc(n26)
N33=vcc(n27)
N34=vcc(n28)
N35=vcc(n29)
n2~mbus_abl*
n3~mbus_nabl*
n4~mbus_dbl*
n5~mbus_ndbl*
]])
      move(nl4, xx, 2980, [[
N2 -25 0 nn27,
N33 -25 4,
N4 -9 0 nn5,
N35 -9 4,
N1 9 0 nn26,
N32 9 4,
N3 25 0 nn4,
N34 25 4,
]])
      route(nl4, xx, 2980, "n3 -18 -1, n5 -16 -1, n2 16 -1, n4 18 -1")
   end
end

local n = nodes_rect(495, 3016, 1350, 2975)
n = merge(n, nodes_rect(500, 3068, 520, 3000))
local nl = match(n, [[
N0=t(y0, n5, n12)
N1=t(y0, n6, n13)
N2=t(y4, n3, n8)
N3=t(y4, n7, n9)
N4=t(y8, n4, n10)
N5=t(n3, y8, n14)
N6=t(n15, x10, n3)
N7=t(n16, x9, n3)
N8=t(n17, x8, n3)
N9=t(n3, x11, n18)
N10=t(n19, n1, n4)
N11=t(n20, x6, n4)
N12=t(n21, x5, n4)
N13=t(n22, x4, n4)
N14=t(n23, x7, n4)
N15=t(n5, y4, n24)
N16=t(n25, x14, n5)
N17=t(n5, x13, n26)
N18=t(n5, x12, n27)
N19=t(n5, x15, n28)
N20=t(n29, n1, n6)
N21=t(n30, x14, n6)
N22=t(n31, x13, n6)
N23=t(n32, x12, n6)
N24=t(n33, x10, n6)
N25=t(n34, x9, n6)
N26=t(n35, x8, n6)
N27=t(n36, x6, n6)
N28=t(n37, x5, n6)
N29=t(n38, x4, n6)
N30=t(n6, x15, n39)
N31=t(n40, x11, n6)
N32=t(n41, x7, n6)
N33=t(n7, n1, n42)
N34=t(n43, x10, n7)
N35=t(n44, x9, n7)
N36=t(n45, x8, n7)
N37=t(n46, x6, n7)
N38=t(n47, x5, n7)
N39=t(n48, x4, n7)
N40=t(n49, x11, n7)
N41=t(n50, x7, n7)
N42=t(n51, n0, y0)
N43=t(n53, n53, n2)
N44=d(n54, n3, n3)
N45=d(n55, n4, n4)
N46=d(n56, n5, n5)
N47=d(n57, n6, n6)
N48=d(n58, n7, n7)
N49=d(n2, y0, y0)
N50=gnd(n8)
N51=gnd(n9)
N52=gnd(n10)
N53=gnd(n11)
N54=gnd(n12)
N100=gnd(n13)
N55=gnd(n14)
N56=gnd(n15)
N57=gnd(n16)
N58=gnd(n17)
N59=gnd(n18)
N60=gnd(n19)
N61=gnd(n20)
N62=gnd(n21)
N63=gnd(n22)
N64=gnd(n23)
N65=gnd(n24)
N66=gnd(n25)
N67=gnd(n26)
N68=gnd(n27)
N69=gnd(n28)
N70=gnd(n29)
N71=gnd(n30)
N72=gnd(n31)
N73=gnd(n32)
N74=gnd(n33)
N75=gnd(n34)
N76=gnd(n35)
N77=gnd(n36)
N78=gnd(n37)
N79=gnd(n38)
N80=gnd(n39)
N81=gnd(n40)
N82=gnd(n41)
N83=gnd(n42)
N84=gnd(n43)
N85=gnd(n44)
N86=gnd(n45)
N87=gnd(n46)
N88=gnd(n47)
N89=gnd(n48)
N90=gnd(n49)
N91=gnd(n50)
N92=vcc(n51)
N93=vcc(n52)
N94=vcc(n53)
N95=vcc(n54)
N96=vcc(n55)
N97=vcc(n56)
N98=vcc(n57)
N99=vcc(n58)
n0~clk_phase_mb_write
]])

move(nl, 0, 0, [[
N42  517 3055 ey0,
N92  516 3059,
N43  517 3040 en2,
N94  516 3044,
N49  517 3032 ey0,
N0   517 3008 en12,
N54  516 3004,
N19  559 3004 en28,
N69  558 3000,
N16  628 3004 en25,
N66  627 3000,
N17  697 3004 en26,
N67  696 3000,
N46  725 3000 en5,
N97  724 3004,
N18  766 3004 en27,
N68  765 3000,
N15  784 3004 en24,
N65  783 3000,
N2   793 3004 en8,
N50  792 3000,
N9   835 3004 en18,
N59  834 3000,
N6   904 3004 en15,
N56  903 3000,
N7   973 3004 en16,
N57  972 3000,
N8  1042 3004 en17,
N58 1041 3000,
N5  1060 3004 en14,
N55 1059 3000,
N44 1069 3004 en3,
N95 1068 3008,
N4  1078 3004 en10,
N52 1077 3000,
N14 1111 3004 en23,
N64 1110 3000,
N11 1180 3004 en20,
N61 1179 3000,
N12 1249 3004 en21,
N62 1248 3000,
N13 1318 3004 en22,
N63 1317 3000,
N10 1336 3004 en19,
N60 1335 3000,
N45 1345 3004 en4,
N96 1344 3008,

N3   793 2993 en9,
N51  792 2989,
N40  835 2993 en49,
N90  834 2989,
N34  904 2993 en43,
N84  903 2989,
N35  973 2993 en44,
N85  972 2989,
N36 1042 2993 en45,
N86 1041 2989,
N41 1111 2993 en50,
N91 1110 2989,
N37 1180 2993 en46,
N87 1179 2989,
N38 1249 2993 en47,
N88 1248 2989,
N39 1318 2993 en48,
N89 1317 2989,
N33 1336 2993 en42,
N83 1335 2989,
N48 1345 2993 en7,
N99 1344 2997,

N1   517 2986 en13,
N100 516 2982,
N30  559 2982 en39,
N80  558 2978,
N21  628 2982 en30,
N71  627 2978,
N22  697 2982 en31,
N72  696 2978,
N23  766 2982 en32,
N73  765 2978,
N31  835 2982 en40,
N81  834 2978,
N24  904 2982 en33,
N74  903 2978,
N25  973 2982 en34,
N75  972 2978,
N26 1042 2982 en35,
N76 1041 2978,
N32 1111 2982 en41,
N82 1110 2978,
N27 1180 2982 en36,
N77 1179 2978,
N28 1249 2982 en37,
N78 1248 2978,
N29 1318 2982 en38,
N79 1317 2978,
N20 1336 2982 en29,
N70 1335 2978,
N47 1345 2982 en6,
N98 1344 2986,
]])
route(nl, 0, 0, [[
y0 512 3051 512 3028 512 3012 512 2990,
y8 1064 3012 1077 3012,
y4 788 3008 788 2997,
n0 533 3055,
n3 1066 3000 1066 3008 797 3008,
n4 1342 3000 1342 3008 1082 3008,
n6 1342 2978 1342 2986,
n7 1342 2989 1342 2997 797 2997,
n5 722 2996 722 3008,
]])

local n = nodes_rect(479, 2970, 490, 2960)
local nl = match(n, "A=t(c, a, b) C=gnd(c)")
move(nl, 0, 0, "A 490 2965 nc, C 486 2964")


local n = nodes_rect(1480, 3018, 1507, 3008)
local nl = match(n, "A=t(c, a, b) B=d(b, b, d) C=gnd(c) D=vcc(d)")
move(nl, 1503, 2995, "B 6 8 eb, D 5 12, A 4 0 wc, C 5 -4")

local n = nodes_rect(1411, 3018, 1437, 3008)
local nl = match(n, "A=t(c, a, b) B=d(b, b, d) C=gnd(c) D=vcc(d)")
move(nl, 1434, 2995, "B 6 8 eb, D 5 12, A 4 0 wc, C 5 -4")

for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-34, 2975, xx+34, 2870)
   local nl1 = register_bit_match_and_place(xx, 2890, "pcl", 15-x, n)
   local nl2 = latch(n, xx-10, 2921)
   local nl3 = match(n, [[
N0=t(n2, nr_2, n7)
N1=t(n8, ro, n3)
N2=t(nr_2, n0, ab)
N3=t(ndb, n1, ro)
N4=t(ro, n0, nab)
N5=t(db, n1, nr_2)
N6=t(n5, n6, ri)
N7=t(n2, n4, nr)
N8=t(n3, n4, r)
N9=gnd(n7)
N10=gnd(n8)
]], { nr_2 = nl2.nr, ro = nl1.ro, ab = nl1.ab, nab = nl1.nab, db = nl1.db, ndb = nl1.ndb, ri = nl1.ri, nr = nl1.nr, r = nl1.r })

   if(x == 15) then
      megabus.pcl_abc = nl1.abc
      megabus.pcl_dbc = nl1.dbc
      megabus.pcl_aul_w = nl3.n4
      megabus.aul_d_w = nl3.n1
      megabus.aul_a_w = nl3.n0
      megabus.aul_alul_w = nl3.n6
   end

   move(nl3, xx, 2930, [[
N6 -1 28 wri,
N4 -12 28 nnab,
N3 -12 24 sndb,
N2 12 28 nnr_2,
N5 12 24 snr_2,
N1 -10 -10 nn8,
N10 -14 -11,
N0 10 -10 nn2,
N9 14 -11,
N8 -7 -15 wr,
N7 7 -15 enr,
]])
   route(nl3, xx, 2930, [[
n5 13 36 0 36,
n6 -5 34,
nab -18 27,
db 18 25,
ro -8 18 -10 18,
ri 0 -3,
nr_2 8 18 10 18 10 1 22 -6,
n4 -11 -19 11 -19,
r -6 -21 8 -21,
nr 6 -23 -8 -23,
]])
end



local n = nodes_rect(545, 2500, 555, 2475)
local nl = match(n, "A=t(b, c, e) B=t(d, a, b) C=vcc(d) D=gnd(e)")
move(nl, 0, 0, "B 558 2490 wb, C 559 2494, A 558 2482 we, D 559 2478")
nl.c:route(552, 2482)

for x=0,11 do
   local xx = 553+69*x
   local n = nodes_rect(xx-34, 2550, xx+34, 2480)
   local nl = match(n, [[
A=t(e, e, a)
B=t(b, f, f)
C=t(c, g, g)
D=t(h, h, d)
E=vcc(e)
F=vcc(f)
G=vcc(g)
H=vcc(h)
a~mbus_nabl*
b~mbus_abl*
c~mbus_ndbl*
d~mbus_dbl*
]])
   move(nl, xx, 2510, [[
A -22 0 ne,
E -22 4,
C -12 0 nc,
G -12 4,
B 12 0 nf,
F 12 4,
D 22 0 nd,
H 22 4,
]])

end

for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-28, 2640, xx+40, 2555)
   local nl = match(n, [[
N0=t(g, h, t)
N1=t(h, g, u)
N2=t(j, g, v)
N3=t(m, e, w)
N4=t(x, o, n)
N5=t(y, e, o)
N6=d(g, g, p)
N7=d(h, h, q)
N8=t(r, h, j)
N9=d(s, o, o)
N10=t(a, i, h)
N11=t(g, f, b)
N12=t(c, i, g)
N13=t(h, f, d)
N14=t(j, l, e)
N15=t(g, k, m)
N16=t(h, k, n)
N17=vcc(p)
N18=vcc(q)
N19=vcc(r)
N20=vcc(s)
N21=gnd(t)
N22=gnd(u)
N23=gnd(v)
N24=gnd(w)
N25=gnd(x)
N26=gnd(y)
a~mbus_abl*
b~mbus_ndbl*
c~mbus_nabl*
d~mbus_dbl*
]])
   move(nl, xx, 2640, [[
N11 -12 0 nb,
N13 12 0 nh,
N12 -12 -4 sc,
N10 12 -4 sh,

N6 -12 -15 eg,
N17 -13 -11,
N0 -10 -23 et,
N21 -11 -27,
N15 -12 -33 em,
N3 -12 -41 ew,
N24 -13 -45,

N8 -10 -54 ej,
N19 -11 -50,
N2 -10 -62 ev,
N23 -11 -66,

N7 12 -15 wh,
N18 13 -11,
N1 10 -23 wu,
N22 11 -27,
N16 12 -33 wn,
N4 12 -41 wx,
N25 13 -45,

N9 10 -54 wo,
N20 11 -50,
N5 10 -62 wy,
N26 11 -66,

N14 -9 -74 nj,
]])
   route(nl, xx, 2640, [[
d 18 -1,
c -18 -3,
g -8 -19 -2 -19 2 -23 -4 -62 -4 -35 6 -35,
h -2 -23 2 -19 8 -19,
k -8 -37 8 -37 12 -37,
e 0 -41 0 -62 0 -75,
j -13 -58,
o 6 -41,

c -18 220,
b -16 220,
a 16 220,
d 18 220,
]])
   nl.e:route(xx, 2560-2*x, 1620, 2560-2*x)

   if(x == 15) then
      megabus.ibuf_d = nl.f
      megabus.ibuf_a = nl.i
      megabus.ib_to_ibuf = nl.k
      megabus.ibuf_to_ib = nl.l
   end
end

local map = {}
for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-48, 2782, xx+40, 2644)
   local nl1 = latchi(n, xx+14, 2702)
   local nl2

   if x == 15 then
      nl2 = match(n, [[
N0=t(n16, n1, n3)
N1=t(n17, n17, n5)
N2=t(n5, n11, n18)
N3=t(n7, nr, n19)
N4=t(n20, n9, n11)
N5=d(n21, n3, n3)
N6=d(n22, n5, n5)
N7=t(n23, n2, n6)
N8=t(n13, n0, n8)
N9=d(n14, n11, n11)
N11=t(n3, n4, ri)
N12=t(ri, n5, n6)
N13=t(nr, n0, n9)
N14=t(n8, n11, n24)
N15=vcc(n13)
N16=vcc(n14)
N18=gnd(n16)
N19=gnd(n17)
N20=gnd(n18)
N21=gnd(n19)
N22=gnd(n20)
N23=vcc(n21)
N24=vcc(n22)
N25=vcc(n23)
N26=gnd(n24)
]], nl1)

   else
      nl2 = match(n, [[
N0=t(n16, n1, n3)
N1=t(n17, n10, n5)
N2=t(n5, n11, n18)
N3=t(n7, nr, n19)
N4=t(n20, n9, n11)
N5=d(n21, n3, n3)
N6=d(n22, n5, n5)
N7=t(n23, n2, n6)
N8=t(n13, n0, n8)
N9=d(n14, n11, n11)
N11=t(n3, n4, ri)
N12=t(ri, n5, n6)
N13=t(nr, n0, n9)
N14=t(n8, n11, n10)
N15=vcc(n13)
N16=vcc(n14)
N18=gnd(n16)
N19=gnd(n17)
N20=gnd(n18)
N21=gnd(n19)
N22=gnd(n20)
N23=vcc(n21)
N24=vcc(n22)
N25=vcc(n23)
]], nl1)
   end

   move(nl2, xx, 2700, [[
N5 10 50 en3,
N23 9 54,
N0 10 42 en16,
N18 9 38,
N11 5 47 nri,
N12 -3 45 sn6,
N7 -8 50 wn6,
N25 -7 54,
N3 -10 29 wn19,
N21 -9 25,

N6 -10 12 wn5,
N24 -9 16,
N1 -10 4 wn17,
N19 -9 0,
N2 -8 -5 wn18,
N20 -7 -9,

N9 -30 -1 en11,
N16 -31 3,
N4 -30 -9 en20,
N22 -31 -13,

N8 -29 25 en8,
N15 -30 29,
N13 -21 25 wn9,
N14 -26 20 sn8,

]])

   route(nl2, xx, 2700, [[
n1 16 42,
n4 5 59,
n2 -12 57,
n0 -25 35,
n5 -7 41 -7 8,
ri 1 41 4 41 4 8,
n9 -20 -9,
n11 -26 -5,
nr -14 19 -5 19 -5 12,
]])

   if nl2.n10 then
      route(nl2, xx, 2700, [[
n10 -22 4,
]])
   else
      move(nl2, xx, 2700, [[
N26 -22 21,
]])

   end

   if(x == 0) then
      nl2.n0:route(511, 2735, 511, 2730, 511, 2725, 528, 2730, 524, 2735)
   end

   if(x == 7) then
      nl2.n10:route(xx-5, 2721, xx-5, 2731, xx+20, 2731, xx+24, 2731, xx+24, 2721)
   elseif(x ~= 15) then
      nl2.n10:route(xx-5, 2721, xx-5, 2731, xx+20, 2731, xx+37, 2731, xx+37, 2721)
   end
   map[string.format("x%d", 15-x)] = nl2.n5

   if(x == 8) then
      local nl3 = match(n, [[
N10=t(n26, n5, n12)
N17=t(n15, n24, n30)
N26=t(n31, n8, n24)
N27=t(n27, n0, n15)
N28=d(n24, n24, n28)
N29=t(n29, n29, n25)
N30=d(n12, n12, n25)
N31=gnd(n26)
N32=vcc(n27)
N33=vcc(n28)
N34=vcc(n29)
N35=gnd(n30)
N36=gnd(n31)
]], nl2)
      move(nl3, xx, 2700, [[
N27 -39 25 en15,
N32 -40 29,
N17 -44 15 en30,
N35 -45 11,
N28 -36 15 wn24,
N33 -35 19,
N26 -34 7 en31,
N36 -35 3,
]])
      route(nl3, xx, 2700, [[
n0 -35 35 -35 30 -25 30 -30 35,
]])
   end

   if(x == 15) then
      megabus.eu_mvm_w = nl2.n4
      megabus.eu_mvm_step = nl2.n2
      megabus.cc_end = nl2.n7
   end
end

local n = nodes_rect(485, 2745, 515, 2730)
local nl = match(n, "A=t(a, c, c) B=d(a, b, b) C=vcc(c)")
move(nl, 0, 0, "A 505 2745 wa, C 506 2749, B 505 2737 wb")

local n = nodes_rect(570, 2685, 1624, 2644)
local nl = match(n, [[
N0=t(n0, x14, n9)
N1=t(n0, x10, n10)
N2=t(n11, x8, n0)
N3=t(n0, x6, n12)
N4=t(n0, x4, n13)
N5=t(n0, x2, n14)
N6=t(n0, x0, n15)
N7=t(n16, x13, n1)
N8=t(n17, x9, n1)
N9=t(n18, x8, n1)
N10=t(n19, x5, n1)
N11=t(n1, x4, n20)
N12=t(n21, x1, n1)
N13=t(n1, x0, n22)
N14=t(n2, x11, n23)
N15=t(n2, x10, n24)
N16=t(n2, x9, n25)
N17=t(n2, x8, n26)
N18=t(n27, x3, n2)
N19=t(n28, x2, n2)
N20=t(n29, x1, n2)
N21=t(n30, x0, n2)
N22=t(n31, x7, n3)
N23=t(n32, x6, n3)
N24=t(n33, x5, n3)
N25=t(n34, x4, n3)
N26=t(n35, x3, n3)
N27=t(n36, x2, n3)
N28=t(n37, x1, n3)
N29=t(n38, x0, n3)
N30=t(n39, n39, n4)
N31=t(n40, n40, n6)
N32=t(n41, n41, n7)
N33=t(n42, n42, n8)
N34=d(n4, n0, n0)
N35=t(n0, x12, n5)
N36=t(n1, x12, n43)
N37=d(n1, n1, n6)
N38=d(n7, n2, n2)
N39=d(n3, n3, n8)
N40=gnd(n9)
N41=gnd(n10)
N42=gnd(n11)
N43=gnd(n12)
N44=gnd(n13)
N45=gnd(n14)
N46=gnd(n15)
N47=gnd(n16)
N48=gnd(n17)
N49=gnd(n18)
N50=gnd(n19)
N51=gnd(n20)
N52=gnd(n21)
N53=gnd(n22)
N54=gnd(n23)
N55=gnd(n24)
N56=gnd(n25)
N57=gnd(n26)
N58=gnd(n27)
N59=gnd(n28)
N60=gnd(n29)
N61=gnd(n30)
N62=gnd(n31)
N63=gnd(n32)
N64=gnd(n33)
N65=gnd(n34)
N66=gnd(n36)
N67=gnd(n37)
N68=gnd(n38)
N69=vcc(n39)
N70=vcc(n40)
N71=vcc(n41)
N72=vcc(n42)
N73=gnd(n35)
N74=gnd(n5)
N75=gnd(n43)
]], map)

move(nl, 0, 0, [[
N30  585 2680 sn39,
N69  581 2681,
N34  593 2680 sn4,

N31  654 2672 sn40,
N70  650 2673,
N37  662 2672 sn6,

N32  792 2664 sn41,
N71  788 2665,
N38  800 2664 sn7,

N33 1068 2656 sn42,
N72 1064 2657,
N39 1076 2656 sn8,

N0   624 2677 wn9,
N40  625 2673,

N7   698 2669 wn16,
N47  699 2665,

N35  762 2677 wn5,
N74  763 2673,
N36  767 2669 wn43,
N75  768 2665,

N14  831 2661 wn23,
N54  832 2657,

N1   900 2677 wn10,
N41  901 2673,
N15  900 2661 wn24,
N55  901 2657,

N8   974 2669 wn17,
N48  975 2665,
N16  969 2661 wn25,
N56  970 2657,

N2  1038 2677 wn11,
N42 1039 2673,
N9  1043 2669 wn18,
N49 1044 2665,
N17 1038 2661 wn26,
N57 1039 2657,

N22 1112 2653 wn31,
N62 1113 2649,

N3  1176 2677 wn12,
N43 1177 2673,
N23 1181 2653 wn32,
N63 1182 2649,

N10 1250 2669 wn19,
N50 1251 2665,
N24 1250 2653 wn33,
N64 1251 2649,

N4  1314 2677 wn13,
N44 1315 2673,
N11 1319 2669 wn20,
N51 1320 2665,
N25 1319 2653 wn34,
N65 1320 2649,

N18 1383 2661 wn27,
N58 1384 2657,
N26 1388 2653 wn35,
N73 1389 2649,

N5  1452 2677 wn14,
N45 1453 2673,
N19 1452 2661 wn28,
N59 1453 2657,
N27 1457 2653 wn36,
N66 1458 2649,

N12 1526 2669 wn21,
N52 1527 2665,
N20 1521 2661 wn29,
N60 1522 2657,
N28 1527 2653 wn37,
N67 1528 2649,

N6  1590 2677 wn15,
N46 1591 2673,
N13 1595 2669 wn22,
N53 1596 2665,
N21 1590 2661 wn30,
N61 1591 2657,
N29 1595 2653 wn38,
N68 1596 2649,
]])

route(nl, 0, 0, [[
x14 620 2699,
x13 689 2699  689 2669,
x12 758 2699  758 2669,
x11 827 2699,
x10 896 2699,
x9  965 2699  965 2669,
x8 1034 2699 1034 2669,
x7 1103 2699 1103 2653,
x6 1172 2699 1172 2653,
x5 1241 2699 1241 2669 1241 2653,
x4 1310 2699 1310 2669 1310 2653,
x3 1379 2699 1379 2653,
x2 1448 2699 1448 2653,
x1 1517 2699 1517 2669 1517 2653,
x0 1586 2699 1586 2669 1586 2653,
]])



megabus.eu_mvm_r0 = nl.n0
megabus.eu_mvm_r1 = nl.n1
megabus.eu_mvm_r2 = nl.n2
megabus.eu_mvm_r3 = nl.n3



for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-34, 2870, xx+34, 2785)
   local nl1 = latchi(n, xx+3, 2790)
   local nl2 = match(n, [[
N0=t(l, ri, a)
N1=t(h, c, m)
N2=t(i, d, n)
N3=t(a, nr, o)
N4=d(h, h, p)
N5=d(i, i, q)
N6=t(ro, k, b)
N7=t(nr, k, d)
N8=t(e, f, ri)
N9=t(ri, g, h)
N10=t(i, j, ri)
N11=gnd(l)
N12=gnd(m)
N13=gnd(n)
N14=vcc(o)
N15=vcc(p)
N16=vcc(q)
b~mbus_abl.*
c~mbus_ndbl.*
d~mbus_nabl.*
]])


   if(x == 15) then
      megabus.aobl0 = nl2.a
      megabus.aobl_r = nl2.k
      megabus.aobl_d_w = nl2.j
      megabus.aobl_a_w = nl2.g
      megabus.aobl_aul_w = nl2.f
   end

   move(nl2, xx, 2780, [[
N7 -12 -1 sd,
N6 12 -1 sro,

N3 13 28 wa,
N14 14 32,
N0 13 20 wl,
N11 14 16,

N5 -12 58 ei,
N16 -13 62,
N2 -14 50 wn,
N13 -13 46,
N10 -4 70 ni,

N4 -2 58 eh,
N15 -3 62,
N1 -4 50 wm,
N12 -3 46,
N9 4 70 nri,

N8 4 82 sri,
]])
   route(nl2, xx, 2780, [[
d -18 0,
a 20 24,
c -16 43 -8 43,
nr -8 2 -8 20 -9 39 9 39,
ro 3 0,
ri 5 20 5 67 0 67,
h 8 58,
g 4 76,
]])

   if(x >= 10) then
      nl2.e:route(xx+22, 2870)
   else
      nl2.e:route(xx+22, 2863)
   end

   if(x == 10) then
      local nl3 = match(n, "N17=t(n0, e, n1) N18=d(n2, n0, n0) N19=gnd(n1) N20=vcc(n2)", nl2)
      move(nl3, xx, 2780, "N17 4 90 en1, N19 3 86, N18 -8 90 nn2, N20 -12 89")
   elseif(x > 10) then
      local nl3 = match(n, "N17=t(n0, e, n1) N18=gnd(n1)", nl2)
      move(nl3, xx, 2780, "N17 4 90 en1, N18 3 86")
      if(x == 15) then
	 megabus.aobl_0_test = nl3.n0
      end
   end
end

for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-29, 1650, xx+39, 1560)
   local nl1 = latch(n, xx-6, 1550)
   local nl2 = match(n, [[
N0=t(n10, n9, n14)
N1=t(n15, n10, n11)
N2=t(ro, n8, n2)
N3=t(nr, n8, n3)
N4=d(n9, n9, n16)
N5=d(n10, n10, n17)
N6=t(n18, n9, n11)
N7=t(n11, n5, n0)
N8=t(n0, n6, ro)
N9=t(n10, n5, n1)
N10=t(n1, n6, nr)
N11=t(n7, n4, n9)
N12=t(ri, n12, n13)
N13=gnd(n14)
N14=gnd(n15)
N15=vcc(n16)
N16=vcc(n17)
N17=vcc(n18)
n0~mbus_ndbd*
n1~mbus_dbd*
n2~mbus_nabd*
n3~mbus_abd*
n13~npl_d*
]], nl1)
   move(nl2, xx, 1540, [[
N12 -5 -7 sn13,

N2 -12 0 sn2,
N3 12 0 snr,
N8 -12 4 nn0,
N10 12 4 nnr,
]])

   route(nl2, xx, 1540, [[
n2 -18 1,
n1 18 3,
ro -6 3,
nr 6 3,
]])

   if(x == 7) then
      nl2.n12:route(1031, 1527, 1610, 1527)
   end

   move(nl2, xx, 1585, [[
N7 -12 0 sn0,
N9 12 0 sn10,

N6 -5 17 en11,
N17 -6 21,
N1 -5 9 en15,
N14 -6 5,

N5 5 17 wn10,
N16 6 21,
N0 5 9 wn14,
N13 6 5,

N4 -10 24 sn16,
N15 -14 25,
N11 3 26 nn9,
]])

   route(nl2, xx, 1585, [[
n1 18 1,
n11 -8 13,
n10 8 13,
]])


   if(x == 15) then
      megabus.y1580 = nl2.n5
      megabus.dbin_to_dbd = nl2.n6
      megabus.dbin_to_abd = nl2.n8
      megabus.dbinl_read = nl2.n12
   end
   if(x == 7) then
      megabus.dbinh_read = nl2.n12
   end
end

local n = nodes_rect(607, 1712, 1620, 1634)
local nl = match(n, [[
N0=t(n116, n20, n74)
N1=t(n8, n9, n75)
N2=t(n10, n11, n76)
N3=t(n12, n13, n77)
N4=t(n14, n15, n78)
N5=t(n16, n17, n79)
N6=t(n80, n10, n18)
N7=t(n81, n8, n20)
N8=t(n82, n12, n21)
N9=t(n83, n14, n22)
N10=t(n84, n16, n23)
N11=t(n85, n7, n26)
N12=t(n26, n10, n86)
N13=t(n28, n12, n87)
N14=t(n29, n14, n88)
N15=t(n30, n16, n89)
N16=t(n90, n21, n31)
N17=t(n91, n22, n32)
N18=t(n92, n23, n33)
N19=t(n93, n26, n34)
N20=t(n94, n7, n35)
N21=t(n95, n10, n35)
N22=t(n0, n6, n9)
N23=t(n1, n6, n11)
N24=t(n2, n6, n13)
N25=t(n3, n6, n15)
N26=t(n4, n6, n17)
N27=t(n5, n6, n19)
N28=d(n7, n7, n96)
N29=d(n8, n8, n97)
N30=d(n10, n10, n98)
N31=d(n12, n12, n99)
N32=d(n14, n14, n100)
N33=d(n16, n16, n101)
N34=d(n18, n18, n102)
N35=d(n20, n20, n103)
N36=d(n21, n21, n104)
N37=d(n22, n22, n105)
N38=d(n23, n23, n106)
N39=d(n25, n25, n107)
N40=d(n26, n26, n108)
N41=d(n27, n27, n109)
N42=t(n110, n21, n28)
N43=t(n111, n22, n29)
N44=t(n112, n23, n30)
N45=t(n113, n12, n31)
N46=t(n114, n14, n32)
N47=t(n115, n16, n33)
N48=t(n7, n19, n24)
N49=t(n9, n20, n20)
N50=t(n11, n18, n18)
N51=t(n13, n21, n21)
N52=t(n15, n22, n22)
N53=t(n17, n23, n23)
N54=t(n27, n25, n19)
N55=t(n117, n6, n25)
N56=t(n118, n7, n27)
N57=t(n34, n28, n36)
N58=t(n34, n28, n40)
N59=t(n37, n28, n35)
N60=t(n35, n28, n38)
N61=t(n36, n31, n41)
N62=t(n37, n31, n42)
N63=t(n38, n31, n39)
N64=t(n39, n29, n43)
N65=t(n39, n29, n49)
N66=t(n40, n29, n44)
N67=t(n40, n29, n50)
N68=t(n41, n29, n45)
N69=t(n41, n29, n46)
N70=t(n42, n29, n47)
N71=t(n42, n29, n48)
N72=t(n43, n32, n51)
N73=t(n44, n32, n52)
N74=t(n45, n32, n53)
N75=t(n46, n32, n54)
N76=t(n47, n32, n55)
N77=t(n48, n32, n56)
N78=t(n49, n32, n57)
N79=t(n50, n30, n58)
N80=t(n51, n30, n71)
N81=t(n72, n30, n51)
N82=t(n59, n30, n52)
N83=t(n52, n30, n60)
N84=t(n61, n30, n53)
N85=t(n53, n30, n62)
N86=t(n54, n30, n63)
N87=t(n64, n30, n54)
N88=t(n65, n30, n55)
N89=t(n55, n30, n66)
N90=t(n67, n30, n56)
N91=t(n56, n30, n68)
N92=t(n57, n30, n69)
N93=t(n70, n30, n57)
N94=vcc(n73)
N95=gnd(n74)
N96=gnd(n75)
N97=gnd(n76)
N98=gnd(n77)
N99=gnd(n78)
N100=gnd(n79)
N101=gnd(n80)
N102=gnd(n81)
N103=gnd(n82)
N104=gnd(n83)
N105=gnd(n84)
N106=gnd(n85)
N107=gnd(n86)
N108=gnd(n87)
N109=gnd(n88)
N110=gnd(n89)
N111=gnd(n90)
N112=gnd(n91)
N113=gnd(n92)
N114=gnd(n93)
N115=gnd(n94)
N116=gnd(n95)
N117=vcc(n96)
N118=vcc(n97)
N119=vcc(n98)
N120=vcc(n99)
N121=vcc(n100)
N122=vcc(n101)
N123=vcc(n102)
N124=vcc(n103)
N125=vcc(n104)
N126=vcc(n105)
N127=vcc(n106)
N128=vcc(n107)
N129=vcc(n108)
N130=vcc(n109)
N131=vcc(n110)
N132=vcc(n111)
N133=vcc(n112)
N134=vcc(n113)
N135=vcc(n114)
N136=vcc(n115)
N137=d(n73, n116, n116)
N138=gnd(n117)
N139=gnd(n118)
N140=gnd(n24)
n0~mbus_abd.4
n1~mbus_abd.3
n2~mbus_abd.2
n3~mbus_abd.1
n4~mbus_abd.0
]])

move(nl, 0, 0, [[
N79   625 1620 nn50,
N82   694 1620 nn52,
N83   763 1620 nn52,
N84   832 1620 nn53,
N85   901 1620 nn53,
N86   970 1620 nn54,
N87  1039 1620 nn54,
N88  1108 1620 nn55,
N89  1177 1620 nn55,
N90  1246 1620 nn56,
N91  1315 1620 nn56,
N92  1384 1620 nn57,
N93  1453 1620 nn57,
N80  1522 1620 nn51,
N81  1591 1620 nn51,

N67   625 1627 nn50,
N73   694 1627 nn52,
N74   832 1627 nn53,
N75   970 1627 nn54,
N76  1108 1627 nn55,
N77  1246 1627 nn56,
N78  1384 1627 nn57,
N72  1522 1627 nn51,

N66   694 1636 nn40,
N68   832 1636 nn41,
N69   970 1636 nn41,
N70  1108 1636 nn42,
N71  1246 1636 nn42,
N65  1384 1636 nn39,
N64  1522 1636 nn39,

N58   694 1643 nn40,
N61   832 1643 nn41,
N62  1246 1643 nn42,
N63  1384 1643 nn39,

N57   832 1652 nn34,
N59  1246 1652 nn35,
N60  1384 1652 nn35,

N19   832 1661 nn34,
N114  836 1660,
N20  1246 1661 nn35,
N115 1250 1660,
N21  1384 1661 nn35,
N116 1388 1660,


N137 1410 1673 wn116,
N94  1411 1677,
N0   1410 1665 wn74,
N95  1411 1661,

N27  1152 1706 nn5,
N54  1175 1701 wn27,

N39  1168 1690 wn25,
N128 1169 1694,
N55  1168 1682 wn117,
N138 1169 1678,

N41  1179 1690 en27,
N130 1178 1694,
N56  1179 1682 en118,
N139 1178 1678,

N28  1197 1690 en7,
N117 1196 1694,
N48  1197 1682 en24,
N140 1196 1678,

N40  1218 1690 wn26,
N129 1219 1694,
N11  1218 1682 wn85,
N106 1219 1678,
N12  1222 1682 en86,
N107 1221 1678,
]])
route(nl, 0, 0, [[
n30  556 1624,
n50  560 1619,
n29  625 1640,
n40  629 1635,
n52  690 1617  759 1617,
n28  694 1656,
n34  698 1651,
n53  828 1617  897 1617,
n41  828 1633  966 1633,
n54  966 1617 1035 1617,
n55 1104 1617 1173 1617,
n42 1104 1633 1242 1633,
n56 1242 1617 1311 1617,
n35 1242 1649 1380 1649,
n57 1380 1617 1449 1617,
n39 1380 1633 1518 1633,
n51 1518 1617 1587 1617,

n20 1304 1665,
n116 1413 1669 1413 1650 1620 1650,
n10 1392 1690 1392 1679 1384 1679 1229 1682 1229 1679,
n25 1171 1686,
n27 1176 1686,
n6 1162 1710 1162 1682,
n26 1212 1690 1212 1665,
n7 1201 1686 1214 1686 1194 1686 1194 1682 1214 1665,
n19 1203 1705 1203 1682,
]])

megabus.y1710 = nl.n6
megabus.y1650 = nl.n116

latch(n, 545+15*69, 1680, { ri = nl.n17 })
latch(n, 545+14*69, 1680, { ri = nl.n15 })
latch(n, 545+13*69, 1680, { ri = nl.n13 })
latch(n, 545+12*69, 1680, { ri = nl.n11 })
latch(n, 545+11*69, 1680, { ri = nl.n9 })

move(nl, 553+15*69, 1710, [[
N26 12 -4 nn17,
N44 -7 -40 en30,
N133 -8 -36,
N15 -7 -48 en89,
N110 -8 -52,
N47 7 -40 wn33,
N136 8 -36,
N18 7 -48 wn92,
N113 8 -52,
]])

route(nl, 553+15*69, 1710, [[
n23 -8 -33 -3 -33,
n16 14 -20 14 -33 3 -33,
n17 2 -5 2 -24,
n30 -10 -44 -10 -86,
n33 10 -44 10 -95,
]])

move(nl, 553+14*69, 1710, [[
N25 12 -4 nn15,
N43 -7 -40 en29,
N132 -8 -36,
N14 -7 -48 en88,
N109 -8 -52,
N46 7 -40 wn32,
N135 8 -36,
N17 7 -48 wn91,
N112 8 -52,
]])

route(nl, 553+14*69, 1710, [[
n22 -8 -33 -3 -33,
n14 14 -20 14 -33 3 -33,
n15 2 -5 2 -24,
n29 -10 -44 -10 -70,
n32 10 -44 10 -79,
]])

move(nl, 553+13*69, 1710, [[
N24 12 -4 nn13,
N42 -7 -40 en28,
N131 -8 -36,
N13 -7 -48 en87,
N108 -8 -52,
N45 7 -40 wn31,
N134 8 -36,
N16 7 -48 wn90,
N111 8 -52,
]])

route(nl, 553+13*69, 1710, [[
n21 -8 -33 -3 -33,
n12 14 -20 14 -33 3 -33,
n13 2 -5 2 -24,
n28 -10 -44 -10 -54,
n31 10 -44 10 -63,
]])

move(nl, 553+12*69, 1710, [[
N23 12 -4 nn11,
]])
route(nl, 553+12*69, 1710, [[
n11 2 -5 2 -24,
]])

move(nl, 553+11*69, 1710, [[
N22 12 -4 nn9,
]])
route(nl, 553+11*69, 1710, [[
n9 2 -5 2 -24,
]])

local n = nodes_rect(495, 2010,  515, 1980)
local nl = match(n, [[
A=t(d, a, b)
B=t(e, a, c)
C=d(f, b, b)
D=t(g, b, c)
E=gnd(d)
F=gnd(e)
G=vcc(f)
H=vcc(g)
]])
move(nl, 0, 0, [[
D 520 1980 ec,
H 519 1984,
B 520 1972 ee,
F 519 1968,
C 528 1980 wb,
G 529 1984,
A 528 1972 wd,
E 529 1968,
]])
route(nl, 0, 0, [[
a 524 1961,
c 517 1976 517 1705,
]])


for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-43, 1145, xx+34, 1000)
   local nl = match(n, [[
A=t(m, g, a)
B=t(c, b, n)
C=t(g, b, o)
D=t(p, f, g)
E=t(q, h, g)
F=t(j, h, r)
G=t(l, e, s)
H=d(t, c, c)
I=d(g, g, u)
J=t(a, f, k)
K=t(c, d, i)
L=t(i, f, j)
M=t(k, h, l)
N=gnd(m)
O=gnd(n)
P=gnd(o)
Q=gnd(p)
R=gnd(q)
S=gnd(r)
T=gnd(s)
U=vcc(t)
V=vcc(u)
N0=t(n8, n3, n4)
N1=t(n0, n7, n9)
N2=t(n10, a, n2)
N3=t(n3, n1, n11)
N4=t(n12, n2, n3)
N5=t(n5, n2, n13)
N6=t(n14, n6, a)
N7=t(n15, c, n7)
N8=d(n4, n4, n16)
N9=d(n3, n3, n17)
N10=d(n18, a, a)
N11=d(n7, n7, n19)
N12=t(n4, n1, n5)
N13=t(n0, a, n1)
N14=gnd(n8)
N15=gnd(n9)
N16=gnd(n10)
N17=gnd(n11)
N18=gnd(n12)
N19=gnd(n13)
N20=gnd(n14)
N21=gnd(n15)
N22=vcc(n16)
N23=vcc(n17)
N24=vcc(n18)
N25=vcc(n19)
N26=t(n21, n20, n0)
N27=d(n22, n2, n2)
N28=vcc(n21)
N29=vcc(n22)
]])
   move(nl, xx, 1000, [[
H -16 39 wc,
U -15 43,
K -14 31 ei,
L -14 23 ej,
F -14 15 er,
S -15 11,

J 12 23 wk,
M 12 15 wl,
G 12 7 ws,
T 13 3,

E -3 34 wq,
R -2 30,
D 3 34 ep,
Q 2 30,

I -4 45 eg,
V -5 49,
A 4 45 wm,
N 5 41,

B -9 55 nc,
O -5 54,
C 4 55 ng,
P 8 54,

N11 -9 78 wn7,
N25 -8 82,
N7 -9 70 wn15,
N21 -8 66,

N10 10 78 wa,
N24 11 82,
N6 10 70 wn14,
N20 11 66,

N1 -4 74 wn9,
N15 -3 70,
N13 1 85 sn0,
N26 -4 90 wn0,
N28 -3 94,

N27 3 104 wn2,
N29 4 108,
N2 9 104 en10,
N16 8 100,
]])
   route(nl, xx, 1000, [[
e 6 7 6 0 20 0,
h -7 15,
f 8 34,
d -10 27 10 27,
g 0 38 0 41 -2 41,
c -13 35,
a 13 49 13 74 1 78,
n6 6 63 20 63,
n0 -15 86,
n20 -8 97 16 97,
n2 6 100 6 108,
n1 5 88 -1 88 -1 99 -6 99,
n4 20 133 20 220 20 293 -3 293,
]])



nl.n4:set_name(string.format("alures%d", 15-x))

   xor(n, xx, 1137)
   if(x == 15) then
      megabus.y1086 = nl.n1
      megabus.y1063 = nl.n6
      megabus.y1059 = nl.b
      megabus.y1027 = nl.d
      megabus.y1000 = nl.e
      megabus.y1059:route(1662, 1059, 1662, 1052)
      megabus.y1027:route(1662, 1027, 1662, 1041)
      megabus.y1000:route(1658, 1000, 1658, 1025, 1668, 1025, 1668, 1028)
	  
	  
	  
	  
	  
   end
end

for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-34, 1525, xx+34, 1408)
   local nl1 = latchi(n, xx+12, 1470)
   local nl2 = match(n, [[
N0=t(n7, ri, n16)
N1=t(n17, n0, n11)
N2=t(n18, n2, n12)
N3=t(n2, n10, n15)
N4=t(n3, n10, n14)
N5=t(n19, nr, n7)
N6=d(n11, n11, n20)
N7=d(n12, n12, n21)
N8=t(n15, n13, n0)
N9=t(n14, n13, n1)
N10=t(n4, n5, n7)
N11=t(ri, n6, n11)
N12=t(n12, n8, ri)
N13=t(ri, n9, n14)
N14=gnd(n16)
N15=gnd(n17)
N16=gnd(n18)
N17=vcc(n19)
N18=vcc(n20)
N19=vcc(n21)
n0~mbus_ndbd.*
n1~mbus_dbd.*
n2~mbus_nabd.*
n3~mbus_abd.*
n4~npl_d.*
]])

   move(nl2, xx, 1410, [[
N3 -12 0 sn2,
N8 -12 4 nn0,
N4 12 0 sn14,
N9 12 4 nn14,

N13 4 11 nri,
N12 4 21 sri,
N11 4 36 nri,
N10 -8 85 nn4,

N7 -10 33 wn12,
N19 -9 37,
N2 -10 25 wn18,
N16 -9 21,

N5 -9 70 en7,
N17 -10 74,
N0 -9 58 en16,
N14 -10 54,

N6 6 58 wn11,
N18 7 62,
N1 6 50 wn17,
N15 7 46,
]])

   route(nl2, xx, 1410, [[
n2 -18 1 -18 25,
n1 18 3,
n12 8 29,
ri 0 58,
n0 -16 50,
n11 9 54 9 35,
n4 -22 84 -16 84 -22 124 -14 124,
n7 -4 82 -12 82 -12 66,
n15 -8 -6 -20 -6,
n14 8 -6 20 -6,

n15 -20 -105, n14 20 -93,
]])


   if(x == 7) then
      nl2.n5:route(xx-8, 1501, 1610, 1501)
      megabus.dbouth_write = nl2.n5
   end
   if(x >= 8) then
      local nl3 = match(n, string.format("N20=t(n23, n22, n4) n23~npl_d.%d", 23-x), nl2)
      nl3.N20:move(xx-8, 1504, "n", nl3.n4)
      nl3.n4:route(xx-22, 1499, xx-22, 1503, xx-16, 1503)
      nl3.n23:route(xx - 574, 1510 + 2*(15-x),
		    xx - 574, 1508 + 2*(15-x),
		    xx - 564, 1510 + 2*(15-x),
		    xx -   4, 1510 + 2*(15-x))
      if(x == 15) then
	 megabus.copy_ext_bytes = nl3.n22
	 megabus.dboutl_write = nl2.n5
	 megabus.y1450 = nl2.n6
	 megabus.y1427 = nl2.n8
	 megabus.y1425 = nl2.n9
	 megabus.y1418 = nl2.n13
	 megabus.y1406 = nl2.n10
	 
	 
	 
      end
   end
end

local map = {}
for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-43, 1408, xx+39, 1325)
   local nl = match(n, [[
N0=t(n3, n4, n15)
N1=t(n4, n3, n16)
N2=t(n5, n4, n17)
N3=t(n7, n9, n18)
N4=t(n19, n12, n11)
N5=t(n20, n9, n12)
N6=d(n3, n3, n21)
N7=d(n4, n4, n22)
N8=t(n23, n3, n5)
N10=d(n24, n12, n12)
N11=t(n0, n2, n3)
N12=t(n1, n2, n4)
N13=t(n3, n6, n11)
N14=t(n4, n6, n7)
N17=gnd(n15)
N18=gnd(n16)
N19=gnd(n17)
N20=gnd(n18)
N21=gnd(n19)
N22=gnd(n20)
N23=vcc(n21)
N24=vcc(n22)
N25=vcc(n23)
N26=vcc(n24)
n0~mbus_ndbd*
n1~mbus_dbd*
]])

   move(nl, xx, 1325, [[
N11 -15 71 en3,
N12 23 71 en4,

N6 -6 70 en3,
N23 -7 74,
N0 -6 62 en15,
N17 -7 58,

N7 8 70 wn4,
N24 9 74,
N1 8 62 wn16,
N18 9 58,

N8 -12 58 wn5,
N25 -11 62,
N2 -10 50 en17,
N19 -11 46,

N13 -15 38 en11,
N4 -15 30 en19,
N21 -16 26,

N14 13 38 wn7,
N3 13 30 wn18,
N20 14 26,

N10 -4 30 wn12,
N26 -3 34,
N5 2 30 en20,
N22 1 26,
]])
   route(nl, xx, 1325, [[
n1 18 75,
n2 -11 77 27 77,
n3 -16 66,
n4 22 66 14 66 14 50 -2 50,
n5 -18 54,
n6 -11 42 9 42,
n12 -1 26 -1 34,
]])


   map[string.format("a%d", 15-x)] = nl.n5
   map[string.format("b%d", 15-x)] = nl.n9

   if(x == 15) then
      megabus.y1402 = nl.n2
      megabus.y1367 = nl.n6
      megabus.y1339 = nl.n9
      megabus.y1335 = nl.n5
   end
end

local n = nodes_rect(530, 1350, 1615, 1335)
local nl = match(n, [[
N0=t(a14, n1, b13)
N1=t(b15, n0, a14)
N2=t(b14, n0, a13)
N3=t(a13, n1, b12)
N4=t(b13, n0, a12)
N5=t(a12, n1, b11)
N6=t(b12, n0, a11)
N7=t(a11, n1, b10)
N8=t(b11, n0, a10)
N9=t(a10, n1, b9)
N10=t(b10, n0, a9)
N11=t(a9, n1, b8)
N12=t(b9, n0, a8)
N13=t(a8, n1, b7)
N14=t(b8, n0, a7)
N15=t(a7, n1, b6)
N16=t(b7, n0, a6)
N17=t(a6, n1, b5)
N18=t(b6, n0, a5)
N19=t(a5, n1, b4)
N20=t(b5, n0, a4)
N21=t(a4, n1, b3)
N22=t(b4, n0, a3)
N23=t(a3, n1, b2)
N24=t(b3, n0, a2)
N25=t(a2, n1, b1)
N26=t(b2, n0, a1)
N27=t(a1, n1, b0)
N28=t(b1, n0, a0)
N29=t(a15, n1, b14)
N30=t(b15, n1, n2)
]])

move(nl, 0, 0, [[
N29  539 1340 na15,
N0   608 1340 na14,
N3   677 1340 na13,
N5   746 1340 na12,
N7   815 1340 na11,
N9   884 1340 na10,
N11  953 1340 na9,
N13 1022 1340 na8,
N15 1091 1340 na7,
N17 1160 1340 na6,
N19 1229 1340 na5,
N21 1298 1340 na4,
N23 1367 1340 na3,
N25 1436 1340 na2,
N27 1505 1340 na1,

N30  555 1340 nn2,

N1   563 1334 sb15,
N2   632 1334 sb14,
N4   701 1334 sb13,
N6   770 1334 sb12,
N8   839 1334 sb11,
N10  908 1334 sb10,
N12  977 1334 sb9,
N14 1046 1334 sb8,
N16 1115 1334 sb7,
N18 1184 1334 sb6,
N20 1253 1334 sb5,
N22 1322 1334 sb4,
N24 1391 1334 sb3,
N26 1460 1334 sb2,
N28 1529 1334 sb1,
]])

route(nl, 0, 0, [[
a14  567 1339,
a13  636 1339,
a12  705 1339,
a11  774 1339,
a10  843 1339,
a9   912 1339,
a8   981 1339,
a7  1050 1339,
a6  1119 1339,
a5  1188 1339,
a4  1257 1339,
a3  1326 1339,
a2  1395 1339,
a1  1464 1339 1501 1328 1620 1328,
a0  1570 1335 1620 1335,

b14  543 1337  628 1337,
b13  632 1339  632 1337  697 1337,
b12  701 1339  701 1337  766 1337,
b11  770 1339  770 1337  835 1337,
b10  839 1339  839 1337  904 1337,
b9   908 1339  908 1337  973 1337,
b8   977 1339  977 1337 1042 1337,
b7  1046 1339 1046 1337 1111 1337,
b6  1115 1339 1115 1337 1180 1337,
b5  1184 1339 1184 1337 1249 1337,
b4  1253 1339 1253 1337 1318 1337,
b3  1322 1339 1322 1337 1387 1337,
b2  1391 1339 1391 1337 1456 1337,
b1  1460 1339 1460 1337 1525 1337,
b0  1594 1339 1620 1339,

a15  535 1324 1620 1324,
n2   551 1326 1620 1326,
n1  1620 1344,
n0  1620 1330,
]])





megabus.y1344 = nl.n1
megabus.y1330 = nl.n0
megabus.y1328 = nl.a1
megabus.y1326 = nl.n2
megabus.y1324 = nl.a15


nl.b0:set_name("alu.shiftin0")
nl.b1:set_name("alu.shiftin1")
nl.b2:set_name("alu.shiftin2")
nl.b3:set_name("alu.shiftin3")
nl.b4:set_name("alu.shiftin4")
nl.b5:set_name("alu.shiftin5")
nl.b6:set_name("alu.shiftin6")
nl.b7:set_name("alu.shiftin7")
nl.b8:set_name("alu.shiftin8")
nl.b9:set_name("alu.shiftin9")
nl.b10:set_name("alu.shiftin10")
nl.b11:set_name("alu.shiftin11")
nl.b12:set_name("alu.shiftin12")
nl.b13:set_name("alu.shiftin13")
nl.b14:set_name("alu.shiftin14")
nl.b15:set_name("alu.shiftin15")
nl.a0:set_name("alu.shiflatch0")

nl.a2:set_name("alu.shiflatch2")
nl.a3:set_name("alu.shiflatch3")
nl.a4:set_name("alu.shiflatch4")
nl.a5:set_name("alu.shiflatch5")
nl.a6:set_name("alu.shiflatch6")
nl.a7:set_name("alu.shiflatch7")
nl.a8:set_name("alu.shiflatch8")
nl.a9:set_name("alu.shiflatch9")
nl.a10:set_name("alu.shiflatch10")
nl.a11:set_name("alu.shiflatch11")
nl.a12:set_name("alu.shiflatch12")
nl.a13:set_name("alu.shiflatch13")
nl.a14:set_name("alu.shiflatch14")


for x=0,15 do
   local xx = 553+69*x
   local n = nodes_rect(xx-34, 1320, xx+34, 1265)
   local nl1 = latchi(n, xx+10, 1295)
   local nl2 = match(n, "A=t(d, ro, c) B=t(ri, a, b) C=gnd(d)", nl1)
   move(nl2, xx, 1295, "B 1 -5 sb, A 6 -15 ed, C 5 -19")

   if(x == 7) then
      nl2.c:route(1048, 1284, 1048, 1273, 1632, 1273, 1632, 1196, 1956, 1196)
      megabus.y1273 = nl2.c
   end
   if(x == 15) then
      nl2.a:route(1620, 1286, 1620, 1304)
      nl2.c:route(1634, 1284, 1634, 1198, 1952, 1198)
      megabus.y1286 = nl2.a
      megabus.y1284 = nl2.c
   end
end

local n = nodes_rect(500, 2055, 510, 2045)
local nl = match(n, "A=t(c, a, b) B=gnd(c)")
move(nl, 511, 2062, "A 0 0 nc, B -4 -1")

local n = nodes_rect(495, 1275, 535, 1250)
local nl = match(n, "A=t(b, a, e) B=t(d, f, f) C=d(c, c, d) D=gnd(e) E=vcc(f)")
move(nl, 0, 0, "A 515 1287 ne, D 511 1286, C 500 1284 ec, B 500 1292 ed, E 499 1296")

local n = nodes_rect(465, 1575, 480, 1565)
local nl = match(n, "A=t(c, a, b) B=gnd(c)")
move(nl, 0, 0, "A 450 1525 wc, B 451 1521")
nl.a:route(446, 1006)

local n = nodes_rect(500, 775, 510, 755)
local nl = match(n, "A=t(c, a, b) B=gnd(c)")
move(nl, 0, 0, "A 540 763 wc, B 541 759")
nl.a:route(296, 763)

local n = nodes_rect(520, 1274, 1615, 1144)
n = merge(n, nodes_rect(1374, 1144, 1377, 1141))
n = merge(n, nodes_rect(1330, 1144, 1355, 1090))
n = merge(n, nodes_rect(1060, 1145, 1085, 1090))
n = merge(n, nodes_rect(1000, 1140, 1010, 1120))
n = merge(n, nodes_rect( 785, 1140,  810, 1040))
n = merge(n, nodes_rect(1127, 1278, 1131, 1274))
n = merge(n, nodes_rect(1619, 1187, 1654, 1171))

local nl = match(n, [[
N0=t(n92, n55, n67)
N1=t(n68, n78, n93)
N2=t(n94, n55, n69)
N3=t(n95, n0, n70)
N4=t(n96, n96, n71)
N5=t(n72, n79, n97)
N6=t(n98, n63, n73)
N7=t(n74, n84, n99)
N8=t(n76, n84, n100)
N9=t(n101, n78, n77)
N10=t(n102, n35, n78)
N11=t(n79, n8, n103)
N12=t(n104, n79, n80)
N13=t(n105, n36, n82)
N14=t(n83, n85, n106)
N15=t(n107, n2, n84)
N16=t(n108, n57, n87)
N17=t(n87, n58, n109)
N18=t(n88, n59, n110)
N19=t(n89, n7, n111)
N20=t(n89, n13, n112)
N21=t(n113, n14, n89)
N22=t(n89, n21, n114)
N23=t(n89, n22, n115)
N24=t(n116, n23, n89)
N25=t(n89, n24, n117)
N26=t(n118, n27, n89)
N27=t(n89, n34, n119)
N28=t(n0, n86, n120)
N29=t(n121, n0, n1)
N30=t(n3, n54, n122)
N31=t(n123, n61, n5)
N32=t(n124, n62, n5)
N33=t(n125, n3, n7)
N34=t(n126, n74, n9)
N35=t(n10, n89, n127)
N36=t(n128, n32, n10)
N37=t(n10, n53, n129)
N38=t(n130, n11, n15)
N39=t(n131, n25, n19)
N40=t(n132, n50, n20)
N41=t(n25, n18, n133)
N42=t(n134, n7, n26)
N43=t(n26, n14, n135)
N44=t(n26, n23, n136)
N45=t(n137, n24, n26)
N46=t(n138, n27, n26)
N47=t(n29, n25, n139)
N48=t(n30, n64, n140)
N49=t(n31, n25, n141)
N50=t(n142, n13, n32)
N51=t(n32, n21, n143)
N52=t(n144, n22, n32)
N53=t(n32, n34, n145)
N54=t(n32, n42, n146)
N55=t(n38, n40, n147)
N56=t(n148, n36, n39)
N57=t(n149, n40, n41)
N58=t(n42, n20, n150)
N59=t(n151, n26, n42)
N60=t(n43, n37, n152)
N61=t(n46, n82, n153)
N62=t(n52, n51, n154)
N63=d(n155, n66, n66)
N64=t(n67, n69, n156)
N65=t(n157, n77, n68)
N66=d(n69, n69, n158)
N67=t(n70, n1, n159)
N68=t(n71, n75, n160)
N69=t(n72, n80, n161)
N70=t(n73, n56, n162)
N71=t(n163, n76, n74)
N72=d(n76, n76, n164)
N73=d(n77, n77, n165)
N74=d(n78, n78, n166)
N75=d(n167, n79, n79)
N76=d(n168, n80, n80)
N77=t(n81, n6, n169)
N78=d(n82, n82, n170)
N79=d(n83, n83, n171)
N80=d(n84, n84, n172)
N81=d(n85, n85, n173)
N82=d(n174, n89, n89)
N83=d(n175, n90, n90)
N84=d(n0, n0, n176)
N85=d(n1, n1, n177)
N86=d(n3, n3, n178)
N87=d(n6, n6, n179)
N88=d(n180, n7, n7)
N89=t(n181, n91, n7)
N90=d(n9, n9, n182)
N91=d(n10, n10, n183)
N92=d(n184, n11, n11)
N93=d(n16, n16, n185)
N94=d(n17, n17, n186)
N95=d(n19, n19, n187)
N96=d(n20, n20, n188)
N97=d(n25, n25, n189)
N98=d(n26, n26, n190)
N99=d(n191, n28, n28)
N100=d(n30, n30, n192)
N101=d(n31, n31, n193)
N102=d(n32, n32, n194)
N103=d(n33, n33, n195)
N104=t(n38, n41, n196)
N105=d(n41, n41, n197)
N106=t(n198, n91, n42)
N107=d(n199, n43, n43)
N108=d(n47, n47, n200)
N109=t(n65, n64, n35)
N110=t(n74, n38, n49)
N111=t(n76, n76, n2)
N112=t(n77, n30, n35)
N113=t(n80, n80, n8)
N115=t(n82, n64, n86)
N116=t(n85, n60, n5)
N117=t(n1, n1, n86)
N118=t(n87, n83, n88)
N119=t(n87, n73, n11)
N121=t(n2, n64, n20)
N122=t(n3, n64, n18)
N124=t(n6, n6, n12)
N125=t(n8, n64, n28)
N126=t(n12, n64, n33)
N127=t(n15, n9, n16)
N128=t(n49, n40, n16)
N129=t(n17, n85, n29)
N130=t(n45, n40, n17)
N131=t(n19, n19, n18)
N132=t(n39, n37, n28)
N133=t(n28, n43, n46)
N134=t(n31, n38, n45)
N135=t(n44, n20, n33)
N136=t(n33, n50, n52)
N137=t(n44, n66, n48)
N138=t(n212, n51, n66)
N139=gnd(n92)
N140=gnd(n93)
N141=gnd(n94)
N142=gnd(n95)
N143=gnd(n96)
N144=gnd(n97)
N145=gnd(n98)
N146=gnd(n99)
N147=gnd(n100)
N148=gnd(n101)
N149=gnd(n102)
N150=gnd(n103)
N151=gnd(n104)
N152=gnd(n105)
N153=gnd(n106)
N154=gnd(n107)
N155=gnd(n108)
N156=gnd(n109)
N157=gnd(n110)
N158=gnd(n111)
N159=gnd(n112)
N160=gnd(n113)
N161=gnd(n114)
N162=gnd(n115)
N163=gnd(n116)
N164=gnd(n117)
N165=gnd(n118)
N166=gnd(n119)
N167=gnd(n120)
N168=gnd(n121)
N169=gnd(n122)
N170=gnd(n123)
N171=gnd(n124)
N172=gnd(n125)
N173=gnd(n126)
N174=gnd(n127)
N175=gnd(n128)
N176=gnd(n129)
N177=gnd(n130)
N178=gnd(n131)
N179=gnd(n132)
N180=gnd(n133)
N181=gnd(n134)
N182=gnd(n135)
N183=gnd(n136)
N184=gnd(n137)
N185=gnd(n138)
N186=gnd(n139)
N187=gnd(n140)
N188=gnd(n141)
N189=gnd(n142)
N190=gnd(n143)
N191=gnd(n144)
N192=gnd(n145)
N193=gnd(n146)
N194=gnd(n147)
N195=gnd(n148)
N196=gnd(n149)
N197=gnd(n150)
N198=gnd(n151)
N199=gnd(n152)
N200=gnd(n153)
N201=gnd(n154)
N202=vcc(n156)
N203=vcc(n157)
N204=vcc(n158)
N205=vcc(n159)
N206=vcc(n160)
N207=vcc(n161)
N208=vcc(n162)
N209=vcc(n163)
N210=vcc(n164)
N211=vcc(n165)
N212=vcc(n166)
N213=vcc(n167)
N214=vcc(n168)
N215=vcc(n169)
N216=vcc(n170)
N217=vcc(n171)
N218=vcc(n172)
N219=vcc(n173)
N220=vcc(n174)
N221=vcc(n175)
N222=vcc(n176)
N223=vcc(n177)
N224=vcc(n178)
N225=vcc(n179)
N226=vcc(n180)
N227=vcc(n181)
N228=vcc(n182)
N229=vcc(n183)
N230=vcc(n184)
N231=vcc(n185)
N232=vcc(n186)
N233=vcc(n187)
N234=vcc(n188)
N235=vcc(n189)
N236=vcc(n190)
N237=vcc(n191)
N238=vcc(n192)
N239=vcc(n193)
N240=vcc(n194)
N241=vcc(n195)
N242=vcc(n196)
N243=vcc(n197)
N244=vcc(n198)
N245=vcc(n199)
N246=vcc(n200)
N247=vcc(n155)
N248=t(n202, n201, n53)
N249=t(n203, n91, n10)
N250=d(n42, n42, n204)
N251=d(n53, n53, n205)
N252=gnd(n202)
N253=vcc(n203)
N254=vcc(n204)
N255=vcc(n205)
N114=t(n81, n90, n207)
N120=t(n90, n12, n208)
N123=t(n209, n90, n6)
N256=t(n210, n206, n4)
N257=d(n211, n4, n4)
N258=gnd(n207)
N259=gnd(n208)
N260=gnd(n209)
N261=gnd(n210)
N262=vcc(n211)
N263=gnd(n48)
N264=gnd(n212)
]])
   

   
latch(n, 1023, 1235, { ri=nl.n2 })
latch(n,  609, 1235, { ri=nl.n8 })
latch(n,  540, 1220, { ri=nl.n86 })
latch(n, 1437, 1228, { ri=nl.n18 })
latch(n, 1161, 1235, { ri=nl.n12 })

move(nl, 0, 0, [[
N68   515 1270 en71,
N206  514 1274,
N4    515 1262 en96,
N143  514 1258,

N78   534 1158 en82,
N216  533 1162,
N13   534 1150 en105,
N152  533 1146,

N99   540 1177 en28,
N237  539 1181,
N132  547 1173 wn39,
N56   547 1165 wn148,
N195  548 1161,
N133  553 1173 en46,
N61   553 1165 en153,
N200  552 1161,

N107  566 1158 wn43,
N245  567 1162,
N60   566 1150 wn152,
N199  567 1146,

N66   580 1268 en69,
N204  579 1272,
N2    580 1260 en94,
N141  579 1256,
N64   588 1268 wn67,
N202  589 1272,
N0    588 1260 wn92,
N139  589 1256,

N108 1090 1294 en47,
N246 1089 1298,

N115  537 1227 nn82,
N67   563 1238 wn70,
N205  564 1242,
N3    563 1230 wn95,
N142  564 1226,

N125  606 1242 nn28,
N69   632 1253 wn72,
N207  633 1257,
N5    632 1245 wn97,
N144  633 1241,

N73   696 1226 en77,
N211  695 1230,
N9    696 1218 en101,
N148  695 1214,
N65   704 1226 wn68,
N203  705 1230,
N1    704 1218 wn93,
N140  705 1214,

N74   704 1206 wn78,
N212  705 1210,
N10   704 1198 wn102,
N149  705 1194,

N100  684 1202 en30,
N238  683 1206,
N48   684 1194 en140,
N187  683 1190,
N112  692 1202 wn35,
N109  688 1180 nn65,

N249  786 1090 en10,
N253  785 1094,

N251  810 1158 en53,
N255  809 1162,
N248  810 1150 en202,
N252  809 1146,

N91   818 1169 wn10,
N229  819 1173,
N37   818 1161 wn129,
N176  819 1157,

N35   824 1189 en127,
N174  823 1185,
N36   824 1174 en128,
N175  823 1170,

N20   839 1185 wn112,
N159  840 1181,
N50   839 1170 wn142,
N189  840 1166,

N22   908 1185 wn114,
N161  909 1181,
N51   908 1170 wn143,
N190  909 1166,

N23   977 1185 wn115,
N162  978 1181,
N52   977 1170 wn144,
N191  978 1166,

N106 1062 1090 en42,
N244 1061 1094,

N250 1026 1167 en42,
N254 1025 1171,
N59  1026 1159 en151,
N198 1025 1155,
N58  1020 1159 wn150,
N197 1021 1155,

N102 1017 1178 en32,
N240 1016 1182,

N27  1046 1185 wn119,
N166 1047 1181,
N53  1046 1170 wn145,
N192 1047 1166,

N24  1115 1185 wn116,
N163 1116 1181,
N44  1115 1170 wn136,
N183 1116 1166,

N21  1184 1185 wn113,
N160 1185 1181,
N43  1184 1170 wn135,
N182 1185 1166,

N26  1253 1185 wn118,
N165 1254 1181,
N46  1253 1170 wn138,
N185 1254 1166,

N25  1322 1185 wn117,
N164 1323 1181,
N45  1322 1170 wn137,
N184 1323 1166,

N121 1020 1242 nn20,
N71  1046 1253 wn74,
N209 1047 1257,
N7   1046 1245 wn99,
N146 1047 1241,

N126 1158 1242 nn33,
N77  1184 1253 wn81,
N215 1185 1257,
N114 1184 1245 wn207,
N258 1185 1241,

N122 1434 1235 nn3,

N89  1338 1090 en7,
N227 1337 1094,

N19  1335 1185 en111,
N158 1334 1181,
N42  1335 1170 en134,
N181 1334 1166,

N88  1342 1150 en7,
N226 1341 1154,
N33  1342 1142 en125,
N172 1341 1138,

N86  1350 1142 wn3,
N224 1351 1146,
N30  1352 1134 en122,
N169 1351 1130,

N82  1348 1189 wn89,
N220 1349 1193,
N98  1348 1174 wn26,
N236 1349 1178,

N102 1060 1174 wn32,
N240 1061 1178,

N54  1038 1170 wn146,
N193 1039 1166,

N96  1086 1158 en20,
N234 1085 1162,
N40  1086 1150 en132,
N179 1085 1146,

N103 1145 1158 wn33,
N241 1146 1162,
N136 1145 1150 wn52,
N62  1145 1142 wn154,
N201 1146 1138,

N63  1145 1123 wn66,
N247 1146 1127,
N138 1145 1115 wn212,
N264 1146 1111,

N137 1135 1123 en48,
N263 1134 1119,
N135 1133 1131 wn44,

N70  1130 1258 wn73,
N208 1131 1262,
N6   1130 1250 wn98,
N145 1131 1246,

N16  1226 1226 wn108,
N155 1227 1222,
N118 1232 1226 en88,
N18  1232 1218 en110,
N157 1231 1214,
N17  1236 1234 en109,
N156 1235 1230,
N119 1230 1242 wn87,
N92  1230 1250 wn11,
N230 1231 1254,

N93  1272 1216 en16,
N231 1271 1220,
N127 1272 1208 en15,
N38  1270 1200 wn130,
N177 1271 1196,

N90  1280 1208 wn9,
N228 1281 1212,
N34  1280 1200 wn126,
N173 1281 1196,

N128 1302 1208 en49,
N110 1300 1200 wn74,

N79  1505 1230 en83,
N217 1504 1234,
N14  1505 1222 en106,
N153 1504 1218,

N81  1513 1222 wn85,
N219 1514 1226,
N116 1513 1214 wn5,
N31  1513 1206 wn123,
N170 1514 1202,
N32  1519 1206 en124,
N171 1518 1202,

N101 1505 1186 en31,
N239 1504 1190,
N49  1505 1178 en141,
N188 1504 1174,

N94  1530 1194 wn17,
N232 1531 1198,
N129 1530 1186 wn29,
N47  1530 1178 wn139,
N186 1531 1174,

N134 1485 1183 nn45,
N130 1485 1179 sn45,

N104 1580 1188 en38,
N242 1579 1192,
N55  1580 1180 en147,
N194 1579 1176,
N105 1588 1188 wn41,
N243 1589 1192,
N57  1588 1180 wn149,
N196 1589 1176,


N257 1598 1238 wn4,
N262 1599 1242,
N256 1600 1230 en210,
N261 1599 1226,
]])

route(nl, 0, 0, [[
n55 569 1253 584 1253,
n67 591 1264 591 1271 1620 1271,
n47 1089 1284,
n37 562 1132 562 1112 573 1112 573 1104 573 1093 573 1086 543 1150,
n82 557 1158 533 1165 538 1165,
n43 562 1173,
n36 540 1150 540 1165,
n1 547 1240 559 1240,
n64 537 1286 606 1286 681 1184 681 1194 681 1189 681 1286 688 1189 684 1184 1020 1286 1158 1286 1434 1286,
n80 616 1255 628 1255,
n72 635 1249 635 1269 1630 1269 1630 1194 1914 1194 1914 1150,
n70 598 1234 598 1267 1628 1267 1628 1192,
n28 602 1177,
n68 713 1222 713 1265 1626 1265 1626 1190 1918 1190 1918 1166,
n77 693 1222,
n35 693 1179,
n65 573 1179,
n91 790 1097 1066 1097 1342 1097 1662 1097 1662 1146,
n10 782 1086 782 1100 782 1121 782 1165 814 1165 821 1165 821 1178 821 1193,
n76 1030 1255 1042 1255,
n81 1187 1249 1187 1263 1624 1263 1624 1188 1916 1188 1916 1157,
n7 1339 1146 1334 1146 1334 1086 1334 1120 1334 1100,
n54 1366 1134,
n3 1353 1138 1353 1234,
n42 1030 1170 1030 1150 1030 1136 1021 1136 1021 1131 1021 1126 1021 1121 1021 1116 1021 1111 1021 1106 1021 1099 1030 1116 1030 1111 1030 1106 1025 1099,
n6 1168 1255 1180 1255,
n51 1139 1142 1139 1115 1139 1086,
n20 1016 1153 1081 1153 1081 1154 1129 1158,
n26 1081 1159 1081 1174,
n33 1134 1158 1154 1154,
n56 1115 1258,
n63 1096 1305 1096 1250,
n57 1196 1226 1196 1280,
n73 1133 1254 1133 1234 1198 1234 1198 1242 1211 1242 1198 1261 1622 1261 1622 1186 1210 1261 1227 1261 1920 1186 1920 1173,
n58 1253 1234,
n59 1255 1218 1255 1259 1322 1259,
n49 1288 1204 1288 966,
n16 1301 1216,
n11 1257 1246 1257 1200,
n74 1050 1249 1050 1191 1276 1191 1301 1191 1326 1191 1326 1259 1620 1259 1620 1184,
n60 1391 1257 1495 1257 1495 1214,
n61 1499 1280 1499 1206,
n62 1529 1206,
n25 1472 1238 1472 1171 1509 1171,
n17 1495 1180 1495 1194,
n85 1523 1218 1523 1186,
n45 1481 966,
n38 1296 1196 1474 1196 1474 1187 1499 1187 1499 1169 1564 1169 1564 1184 1564 964,
n4 1620 1234,
n40 1464 1208 1464 1175 1495 1175 1495 1167 1584 1167 1620 1167,
]])





megabus.y1271 = nl.n67
megabus.y1269 = nl.n72
megabus.y1267 = nl.n70
megabus.y1265 = nl.n68
megabus.y1263 = nl.n81
megabus.y1261 = nl.n73
megabus.y1259 = nl.n74
megabus.y1234 = nl.n4
megabus.y1167 = nl.n40
megabus.y1097 = nl.n91

nl.n38:set_name("aluen.Ncorf.buf.buf")
nl.n45:set_name("alu.lownybblefixup")
nl.n3:set_name("alu.halfcarry")
nl.n25:set_name("alu.Nhalfcarry.latched")
nl.n31:set_name("alu.lownybblefixup.sub")
nl.n17:set_name("alu.lownybblefixup.add")
nl.n85:set_name("alu.Nlownybblegreaterthan9")
nl.n83:set_name("alu.lownybblegreaterthan9")
nl.n11:set_name("alu.Nhighnybbleequalorgreaterthan9")
nl.n16:set_name("alu.highnybblefixup.add")
nl.n49:set_name("alu.highnybblefixup")
nl.n47:set_name("alu.lowbytezero")
nl.n28:set_name("alu.vflag_word")
nl.n33:set_name("alu.vflag_byte")
nl.n20:set_name("alu.cflag_byte")
nl.n10:set_name("alu.upperbytehalfcarry")
nl.n64:set_name("aluen.eu_w.gated.alurl")

nl.n62:set_name("alures1.latched")
nl.n61:set_name("alures2.latched")
nl.n60:set_name("alures3.latched")
nl.n59:set_name("alures4.latched")
nl.n58:set_name("alures5.latched")
nl.n57:set_name("alures6.latched")
nl.n56:set_name("alures7.latched")

nl.n26:set_name("alu.bit7to4.carrylookahead")
nl.n32:set_name("alu.bit11to8.carrylookahead")
nl.n89:set_name("alu.bit11to4.carrylookahead")


local n = nodes_rect(445, 3210, 505, 3030)
n = merge(n, nodes_rect(485, 3480, 500, 3470))
local nl = match(n, [[
N0=t(n3, n0, n24)
N1=t(n25, n2, n3)
N2=t(n3, n5, n26)
N3=t(n4, n2, n27)
N4=t(n4, n5, n28)
N5=t(n6, n0, n29)
N6=t(n30, n1, n6)
N7=t(n6, n10, n31)
N8=t(n7, n0, n32)
N9=t(n33, n1, n7)
N10=t(n7, n12, n34)
N11=t(n8, n1, n15)
N12=t(n16, n10, n8)
N13=t(n9, n0, n17)
N14=t(n18, n2, n9)
N15=t(n9, n11, n19)
N16=t(n13, n1, n20)
N17=t(n21, n12, n13)
N18=t(n14, n2, n22)
N19=t(n23, n11, n14)
N20=t(n3, n4, n35)
N21=d(n4, n4, n36)
N22=t(n6, n8, n37)
N23=t(n7, n13, n38)
N24=d(n8, n8, n39)
N25=t(n9, n14, n40)
N26=d(n13, n13, n41)
N27=d(n14, n14, n42)
N28=gnd(n15)
N29=gnd(n16)
N30=gnd(n17)
N31=gnd(n18)
N32=gnd(n19)
N33=gnd(n20)
N34=gnd(n21)
N35=gnd(n22)
N36=gnd(n23)
N37=gnd(n24)
N38=gnd(n25)
N39=gnd(n26)
N40=gnd(n27)
N41=gnd(n28)
N42=gnd(n29)
N43=gnd(n30)
N44=gnd(n31)
N45=gnd(n32)
N46=gnd(n33)
N47=gnd(n34)
N48=vcc(n35)
N49=vcc(n36)
N50=vcc(n37)
N51=vcc(n38)
N52=vcc(n39)
N53=vcc(n40)
N54=vcc(n41)
N55=vcc(n42)
N56=t(n43, n0, n44)
N57=gnd(n44)
n0~precharge
n5~mbus_abl.15
n10~mbus_ndbl.15
n11~mbus_nabl.15
n12~mbus_dbl.15
]])

move(nl, 0, 0, [[
N21 470 3198 en4,
N49 469 3202,
N3  470 3190 en27,
N40 469 3186,
N4  468 3182 en28,
N41 467 3178,

N20 478 3198 wn3,
N48 479 3202,
N1  478 3190 wn25,
N38 479 3186,
N2  480 3182 wn26,
N39 481 3178,

N24 470 3158 en8,
N52 469 3162,
N11 470 3150 en15,
N28 469 3146,
N12 468 3142 en16,
N29 467 3138,

N22 478 3158 wn6,
N50 479 3162,
N6  478 3150 wn30,
N43 479 3146,
N7  480 3142 wn31,
N44 481 3138,

N26 470 3118 en13,
N54 469 3122,
N16 470 3110 en20,
N33 469 3106,
N17 468 3102 en21,
N34 467 3098,

N23 478 3118 wn7,
N51 479 3122,
N9  478 3110 wn33,
N46 479 3106,
N10 480 3102 wn34,
N47 481 3098,

N27 470 3078 en14,
N55 469 3082,
N18 470 3070 en22,
N35 469 3066,
N19 468 3062 en23,
N36 467 3058,

N25 478 3078 wn9,
N53 479 3082,
N14 478 3070 wn18,
N31 479 3066,
N15 480 3062 wn19,
N32 481 3058,

N56 494 3479 wn44,
N57 495 3475,
N0  486 3182 en24,
N37 485 3178,
N5  486 3142 en29,
N42 485 3138,
N8  486 3102 en32,
N45 485 3098,
N13 486 3062 en17,
N30 485 3058,
]])

route(nl, 0, 0, [[
n0  490 3218,
n4  467 3194,
n3  481 3194 486 3194 513 3194 513 3180,
n8  467 3154,
n6  481 3154 513 3154 513 3178,
n13 467 3114,
n7  481 3114 511 3114 511 3176,
n14 467 3074,
n9  481 3074 509 3074 509 3174,
n2  474 3175 465 3175 465 3155 465 3071 465 3063
    474 3055 465 3055 474 3062
    465 3332 1620 3332 465 3190 465 3182 474 3182 470 3175,
n1  474 3135 463 3135 474 3095 463 3095 463 3110 463 3102 474 3102 470 3095
    463 3330 1620 3330 463 3150 463 3142 474 3142 470 3135,
n5  476 3175 507 3175 507 3138 569 3138,
n10 476 3135 492 3135 492 3136 537 3136,
n12 476 3095 507 3095 507 3134 571 3134,
n11 476 3055 505 3055 535 3057
             505 3070 535 3072
             505 3085 535 3087
             505 3100 535 3102
             505 3115 535 3117
             505 3132 535 3132,
]])



megabus.ha_active = nl.n2
megabus.hd_active = nl.n1

rename(megabus, "eu.")

megabus.y968:set_name("alu.rightrotatecarryin_word.buf")

megabus.y863:set_name("aluen.Naboea.buf")
megabus.y870:set_name("alu.rightrotatecarryin_byteandlong.buf")
megabus.y875:set_name("en.rotate_byte")
megabus.y885:set_name("alu.mbus_abd.7")

megabus.y896:set_name("en.csrbuf_and_nano17")
megabus.y903:set_name("aluen.sub.buf.buf")
megabus.y910:set_name("aluen.Nsub.buf.buf")
megabus.y936:set_name("en.Nnano17")
megabus.y943:set_name("aluen.Ncsr.buf.buf")
megabus.y950:set_name("en.Nnano16_and_nano15.buf")
megabus.y957:set_name("en.eu_r.Nnano15_and_Nnano16.buf")
megabus.y986:set_name("en.nano16.buf")
megabus.y993:set_name("en.Nnano15.buf")

megabus.y1000:set_name("aluen.cor.buf.buf")
megabus.y1027:set_name("aluen.cxor.buf.buf")
megabus.y1059:set_name("aluen.Ncand.buf.buf")
megabus.y1086:set_name("Nalu.addercarryin")
megabus.y1063:set_name("aluen.Ncsl.buf.buf")

megabus.y1330:set_name("eu_r.gated.Ncsl.buf_leftshift")
megabus.y1344:set_name("eu_r.gated.csl.buf_rightshift")
megabus.y1326:set_name("alu.Nrightrotatecarryin_byteandlong")
megabus.y1328:set_name("alu.shiflatch1")
megabus.y1263:set_name("alu.vflag_byte.latched")
megabus.y1269:set_name("alu.vflag_word.latched")
megabus.y1097:set_name("alu.eu_r.buf")

megabus.y1167:set_name("aluen.corf.buf")

megabus.y1339:set_name("alu.Nleftrotatecarryin_long")

megabus.y1284:set_name("alu.zflag_byte")
megabus.y1273:set_name("alu.zflag_word")
megabus.y1367:set_name("en.eu_w_forlshiftandrshift")
megabus.y1335:set_name("alu.shiftlatch0")
megabus.y1406:set_name("eu_r.gated.alureslatch_to_mbus_abd")
megabus.y1418:set_name("eu_r.gated.alureslatch_to_mbus_dbd")
megabus.y1450:set_name("eu_r.gated.mbus_dbd_to_npl_d")
megabus.y1425:set_name("eu_r.gated.alureslatch_to_npl_d")
megabus.y1427:set_name("eu_r.gated.mbus_abd_to_npl_d")
megabus.y1580:set_name("eu_r.gated.bitgenerator_to_mbus_dbd")
megabus.y1710:set_name("eu_w.gated.mbus_abd_to_bitgeneratorselect")

--megabus.y:set_name("")
